## GtkWidget GtkWidget — Base class for all widgets |

## Functions

#define | GTK_WIDGET_TYPE()
#define | GTK_WIDGET_STATE()
#define | GTK_WIDGET_SAVED_STATE()
#define | GTK_WIDGET_FLAGS()
#define | GTK_WIDGET_TOPLEVEL()
#define | GTK_WIDGET_NO_WINDOW()
#define | GTK_WIDGET_REALIZED()
#define | GTK_WIDGET_MAPPED()
#define | GTK_WIDGET_VISIBLE()
#define | GTK_WIDGET_DRAWABLE()
#define | GTK_WIDGET_SENSITIVE()
#define | GTK_WIDGET_PARENT_SENSITIVE()
#define | GTK_WIDGET_IS_SENSITIVE()
#define | GTK_WIDGET_CAN_FOCUS()
#define | GTK_WIDGET_HAS_FOCUS()
#define | GTK_WIDGET_CAN_DEFAULT()
#define | GTK_WIDGET_RECEIVES_DEFAULT()
#define | GTK_WIDGET_HAS_DEFAULT()
#define | GTK_WIDGET_HAS_GRAB()
#define | GTK_WIDGET_RC_STYLE()
#define | GTK_WIDGET_COMPOSITE_CHILD()
#define | GTK_WIDGET_APP_PAINTABLE()
#define | GTK_WIDGET_DOUBLE_BUFFERED()
#define | GTK_WIDGET_SET_FLAGS()
#define | GTK_WIDGET_UNSET_FLAGS()
void | (*GtkCallback) ()
GtkWidget * | gtk_widget_new ()
GtkWidget * | gtk_widget_ref ()
void | gtk_widget_unref ()
void | gtk_widget_destroy ()
void | gtk_widget_destroyed ()
void | gtk_widget_set ()
void | gtk_widget_unparent ()
void | gtk_widget_show ()
void | gtk_widget_show_now ()
void | gtk_widget_hide ()
void | gtk_widget_show_all ()
void | gtk_widget_hide_all ()
void | gtk_widget_map ()
void | gtk_widget_unmap ()
void | gtk_widget_realize ()
void | gtk_widget_unrealize ()
void | gtk_widget_queue_draw ()
void | gtk_widget_queue_resize ()
void | gtk_widget_queue_resize_no_redraw ()
void | gtk_widget_draw ()
void | gtk_widget_size_request ()
void | gtk_widget_get_child_requisition ()
void | gtk_widget_size_allocate ()
void | gtk_widget_add_accelerator ()
gboolean | gtk_widget_remove_accelerator ()
void | gtk_widget_set_accel_path ()
GList * | gtk_widget_list_accel_closures ()
gboolean | gtk_widget_can_activate_accel ()
gboolean | gtk_widget_event ()
gboolean | gtk_widget_activate ()
void | gtk_widget_reparent ()
gboolean | gtk_widget_intersect ()
gboolean | gtk_widget_is_focus ()
void | gtk_widget_grab_focus ()
void | gtk_widget_grab_default ()
void | gtk_widget_set_name ()
const gchar * | gtk_widget_get_name ()
void | gtk_widget_set_state ()
void | gtk_widget_set_sensitive ()
void | gtk_widget_set_parent ()
void | gtk_widget_set_parent_window ()
GdkWindow * | gtk_widget_get_parent_window ()
void | gtk_widget_set_uposition ()
void | gtk_widget_set_usize ()
void | gtk_widget_set_events ()
void | gtk_widget_add_events ()
void | gtk_widget_set_extension_events ()
GdkExtensionMode | gtk_widget_get_extension_events ()
GtkWidget * | gtk_widget_get_toplevel ()
GtkWidget * | gtk_widget_get_ancestor ()
GdkColormap * | gtk_widget_get_colormap ()
void | gtk_widget_set_colormap ()
GdkVisual * | gtk_widget_get_visual ()
gint | gtk_widget_get_events ()
void | gtk_widget_get_pointer ()
gboolean | gtk_widget_is_ancestor ()
gboolean | gtk_widget_translate_coordinates ()
gboolean | gtk_widget_hide_on_delete ()
void | gtk_widget_set_style ()
#define | gtk_widget_set_rc_style()
void | gtk_widget_ensure_style ()
GtkStyle * | gtk_widget_get_style ()
#define | gtk_widget_restore_default_style()
void | gtk_widget_reset_rc_styles ()
void | gtk_widget_push_colormap ()
void | gtk_widget_pop_colormap ()
void | gtk_widget_set_default_colormap ()
GtkStyle * | gtk_widget_get_default_style ()
GdkColormap * | gtk_widget_get_default_colormap ()
GdkVisual * | gtk_widget_get_default_visual ()
void | gtk_widget_set_direction ()
GtkTextDirection | gtk_widget_get_direction ()
void | gtk_widget_set_default_direction ()
GtkTextDirection | gtk_widget_get_default_direction ()
void | gtk_widget_shape_combine_mask ()
void | gtk_widget_input_shape_combine_mask ()
void | gtk_widget_path ()
void | gtk_widget_class_path ()
gchar * | gtk_widget_get_composite_name ()
void | gtk_widget_modify_style ()
GtkRcStyle * | gtk_widget_get_modifier_style ()
void | gtk_widget_modify_fg ()
void | gtk_widget_modify_bg ()
void | gtk_widget_modify_text ()
void | gtk_widget_modify_base ()
void | gtk_widget_modify_font ()
void | gtk_widget_modify_cursor ()
PangoContext * | gtk_widget_create_pango_context ()
PangoContext * | gtk_widget_get_pango_context ()
PangoLayout * | gtk_widget_create_pango_layout ()
GdkPixbuf * | gtk_widget_render_icon ()
void | gtk_widget_pop_composite_child ()
void | gtk_widget_push_composite_child ()
void | gtk_widget_queue_clear ()
void | gtk_widget_queue_clear_area ()
void | gtk_widget_queue_draw_area ()
void | gtk_widget_reset_shapes ()
void | gtk_widget_set_app_paintable ()
void | gtk_widget_set_double_buffered ()
void | gtk_widget_set_redraw_on_allocate ()
void | gtk_widget_set_composite_name ()
gboolean | gtk_widget_set_scroll_adjustments ()
gboolean | gtk_widget_mnemonic_activate ()
void | gtk_widget_class_install_style_property ()
void | gtk_widget_class_install_style_property_parser ()
GParamSpec * | gtk_widget_class_find_style_property ()
GParamSpec ** | gtk_widget_class_list_style_properties ()
GdkRegion * | gtk_widget_region_intersect ()
gint | gtk_widget_send_expose ()
gboolean | gtk_widget_send_focus_change ()
void | gtk_widget_style_get ()
void | gtk_widget_style_get_property ()
void | gtk_widget_style_get_valist ()
void | gtk_widget_style_attach ()
AtkObject * | gtk_widget_get_accessible ()
gboolean | gtk_widget_child_focus ()
void | gtk_widget_child_notify ()
void | gtk_widget_freeze_child_notify ()
gboolean | gtk_widget_get_child_visible ()
GtkWidget * | gtk_widget_get_parent ()
GtkSettings * | gtk_widget_get_settings ()
GtkClipboard * | gtk_widget_get_clipboard ()
GdkDisplay * | gtk_widget_get_display ()
GdkWindow * | gtk_widget_get_root_window ()
GdkScreen * | gtk_widget_get_screen ()
gboolean | gtk_widget_has_screen ()
void | gtk_widget_get_size_request ()
#define | gtk_widget_pop_visual
#define | gtk_widget_push_visual()
void | gtk_widget_set_child_visible ()
#define | gtk_widget_set_default_visual()
void | gtk_widget_set_size_request ()
#define | gtk_widget_set_visual()
void | gtk_widget_thaw_child_notify ()
void | gtk_widget_set_no_show_all ()
gboolean | gtk_widget_get_no_show_all ()
GList * | gtk_widget_list_mnemonic_labels ()
void | gtk_widget_add_mnemonic_label ()
void | gtk_widget_remove_mnemonic_label ()
GtkAction * | gtk_widget_get_action ()
gboolean | gtk_widget_is_composited ()
void | gtk_widget_error_bell ()
gboolean | gtk_widget_keynav_failed ()
gchar * | gtk_widget_get_tooltip_markup ()
void | gtk_widget_set_tooltip_markup ()
gchar * | gtk_widget_get_tooltip_text ()
void | gtk_widget_set_tooltip_text ()
GtkWindow * | gtk_widget_get_tooltip_window ()
void | gtk_widget_set_tooltip_window ()
gboolean | gtk_widget_get_has_tooltip ()
void | gtk_widget_set_has_tooltip ()
void | gtk_widget_trigger_tooltip_query ()
GdkPixmap * | gtk_widget_get_snapshot ()
GdkWindow * | gtk_widget_get_window ()
void | gtk_widget_get_allocation ()
void | gtk_widget_set_allocation ()
gboolean | gtk_widget_get_app_paintable ()
gboolean | gtk_widget_get_can_default ()
void | gtk_widget_set_can_default ()
gboolean | gtk_widget_get_can_focus ()
void | gtk_widget_set_can_focus ()
gboolean | gtk_widget_get_double_buffered ()
gboolean | gtk_widget_get_has_window ()
void | gtk_widget_set_has_window ()
gboolean | gtk_widget_get_sensitive ()
gboolean | gtk_widget_is_sensitive ()
GtkStateType | gtk_widget_get_state ()
gboolean | gtk_widget_get_visible ()
void | gtk_widget_set_visible ()
gboolean | gtk_widget_has_default ()
gboolean | gtk_widget_has_focus ()
gboolean | gtk_widget_has_grab ()
gboolean | gtk_widget_has_rc_style ()
gboolean | gtk_widget_is_drawable ()
gboolean | gtk_widget_is_toplevel ()
void | gtk_widget_set_window ()
void | gtk_widget_set_receives_default ()
gboolean | gtk_widget_get_receives_default ()
void | gtk_widget_set_realized ()
gboolean | gtk_widget_get_realized ()
void | gtk_widget_set_mapped ()
gboolean | gtk_widget_get_mapped ()
void | gtk_widget_get_requisition ()
GtkRequisition * | gtk_requisition_copy ()
void | gtk_requisition_free ()

## Properties

gboolean | app-paintable | Read / Write
gboolean | can-default | Read / Write
gboolean | can-focus | Read / Write
gboolean | composite-child | Read
gboolean | double-buffered | Read / Write
GdkEventMask | events | Read / Write
GdkExtensionMode | extension-events | Read / Write
gboolean | has-default | Read / Write
gboolean | has-focus | Read / Write
gboolean | has-tooltip | Read / Write
gint | height-request | Read / Write
gboolean | is-focus | Read / Write
gchar * | name | Read / Write
gboolean | no-show-all | Read / Write
GtkContainer * | parent | Read / Write
gboolean | receives-default | Read / Write
gboolean | sensitive | Read / Write
GtkStyle * | style | Read / Write
gchar * | tooltip-markup | Read / Write
gchar * | tooltip-text | Read / Write
gboolean | visible | Read / Write
gint | width-request | Read / Write
GdkWindow * | window | Read

## Style Properties

gfloat | cursor-aspect-ratio | Read
GdkColor * | cursor-color | Read
GtkBorder * | draw-border | Read
gchar * | focus-line-pattern | Read
gint | focus-line-width | Read
gint | focus-padding | Read
gboolean | interior-focus | Read
GdkColor * | link-color | Read
gint | scroll-arrow-hlength | Read
gint | scroll-arrow-vlength | Read
GdkColor * | secondary-cursor-color | Read
gint | separator-height | Read
gint | separator-width | Read
guchar | tooltip-alpha | Read
guint | tooltip-radius | Read
GdkColor * | visited-link-color | Read
gboolean | wide-separators | Read

## Signals

void | accel-closures-changed |
gboolean | button-press-event | Run Last
gboolean | button-release-event | Run Last
gboolean | can-activate-accel | Run Last
void | child-notify | No Hooks
gboolean | client-event | Run Last
void | composited-changed | Action
gboolean | configure-event | Run Last
gboolean | damage-event | Run Last
gboolean | delete-event | Run Last
gboolean | destroy-event | Run Last
void | direction-changed | Run First
void | drag-begin | Run Last
void | drag-data-delete | Run Last
void | drag-data-get | Run Last
void | drag-data-received | Run Last
gboolean | drag-drop | Run Last
void | drag-end | Run Last
gboolean | drag-failed | Run Last
void | drag-leave | Run Last
gboolean | drag-motion | Run Last
gboolean | enter-notify-event | Run Last
gboolean | event | Run Last
void | event-after |
gboolean | expose-event | Run Last
gboolean | focus | Run Last
gboolean | focus-in-event | Run Last
gboolean | focus-out-event | Run Last
gboolean | grab-broken-event | Run Last
void | grab-focus | Action
void | grab-notify | Run First
void | hide | Run First
void | hierarchy-changed | Run Last
gboolean | key-press-event | Run Last
gboolean | key-release-event | Run Last
gboolean | keynav-failed | Run Last
gboolean | leave-notify-event | Run Last
void | map | Run First
gboolean | map-event | Run Last
gboolean | mnemonic-activate | Run Last
gboolean | motion-notify-event | Run Last
void | move-focus | Action
gboolean | no-expose-event | Run Last
void | parent-set | Run First
gboolean | popup-menu | Action
gboolean | property-notify-event | Run Last
gboolean | proximity-in-event | Run Last
gboolean | proximity-out-event | Run Last
gboolean | query-tooltip | Run Last
void | realize | Run First
void | screen-changed | Run Last
gboolean | scroll-event | Run Last
gboolean | selection-clear-event | Run Last
void | selection-get | Run Last
gboolean | selection-notify-event | Run Last
void | selection-received | Run Last
gboolean | selection-request-event | Run Last
void | show | Run First
gboolean | show-help | Action
void | size-allocate | Run First
void | size-request | Run First
void | state-changed | Run First
void | style-set | Run First
void | unmap | Run First
gboolean | unmap-event | Run Last
void | unrealize | Run Last
gboolean | visibility-notify-event | Run Last
gboolean | window-state-event | Run Last

## Types and Values

| GtkWidget
struct | GtkWidgetClass
enum | GtkWidgetFlags
struct | GtkRequisition
typedef | GtkAllocation
| GtkSelectionData
struct | GtkWidgetAuxInfo
struct | GtkWidgetShapeInfo
enum | GtkWidgetHelpType
enum | GtkTextDirection

## Object Hierarchy

        GBoxed
        ├── GtkRequisition
        ╰── GtkSelectionData
        GObject
        ╰── GInitiallyUnowned
            ╰── GtkObject
                ╰── GtkWidget
                    ├── GtkContainer
                    ├── GtkMisc
                    ├── GtkCalendar
                    ├── GtkCellView
                    ├── GtkDrawingArea
                    ├── GtkEntry
                    ├── GtkRuler
                    ├── GtkRange
                    ├── GtkSeparator
                    ├── GtkHSV
                    ├── GtkInvisible
                    ├── GtkOldEditable
                    ├── GtkPreview
                    ╰── GtkProgress

## Known Derived Interfaces

GtkWidget is required by GtkCellEditable, GtkFileChooser and GtkToolShell.

## Implemented Interfaces

GtkWidget implements AtkImplementorIface and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

GtkWidget is the base class all widgets in GTK+ derive from. It manages the widget lifecycle, states and style.

GtkWidget introduces style properties - these are basically object properties that are stored not on the object, but in the style object associated to the widget. Style properties are set in resource files. This mechanism is used for configuring such things as the location of the scrollbar arrows through the theme, giving theme authors more control over the look of applications without the need to write a theme engine in C.

Use `gtk_widget_class_install_style_property()` to install style properties for a widget class, `gtk_widget_class_find_style_property()` or `gtk_widget_class_list_style_properties()` to get information about existing style properties and `gtk_widget_style_get_property()`, `gtk_widget_style_get()` or `gtk_widget_style_get_valist()` to obtain the value of a style property.

### GtkWidget as GtkBuildable

The GtkWidget implementation of the GtkBuildable interface supports a custom <accelerator> element, which has attributes named key, modifiers and signal and allows to specify accelerators.

Example 14. A UI definition fragment specifying an accelerator

    1
    2
    3
    <object class="GtkButton">
      <accelerator key="q" modifiers="GDK_CONTROL_MASK" signal="clicked"/>
    </object>

In addition to accelerators, GtkWidget also support a custom <accessible> element, which supports actions and relations. Properties on the accessible implementation of an object can be set by accessing the internal child "accessible" of a GtkWidget.

Example 15. A UI definition fragment specifying an accessible

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    <object class="GtkButton" id="label1"/>
      <property name="label">I am a Label for a Button</property>
    </object>
    <object class="GtkButton" id="button1">
      <accessibility>
        <action action_name="click" translatable="yes">Click the button.</action>
        <relation target="label1" type="labelled-by"/>
      </accessibility>
      <child internal-child="accessible">
        <object class="AtkObject" id="a11y-button1">
          <property name="AtkObject::name">Clickable Button</property>
        </object>
      </child>
    </object>

## Functions

### GTK_WIDGET_TYPE()

    #define GTK_WIDGET_TYPE(wid)		  (GTK_OBJECT_TYPE (wid))

`GTK_WIDGET_TYPE` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `G_OBJECT_TYPE()` instead.

Gets the type of a widget.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_STATE()

    #define GTK_WIDGET_STATE(wid)		  (GTK_WIDGET (wid)->state)

`GTK_WIDGET_STATE` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_state()` instead.

Returns the current state of the widget, as a GtkStateType.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_SAVED_STATE()

    #define GTK_WIDGET_SAVED_STATE(wid)	  (GTK_WIDGET (wid)->saved_state)

`GTK_WIDGET_SAVED_STATE` has been deprecated since version 2.20 and should not be used in newly-written code.

Do not used it.

Returns the saved state of the widget, as a GtkStateType.

The saved state will be restored when a widget gets sensitive again, after it has been made insensitive with `gtk_widget_set_state()` or `gtk_widget_set_sensitive()`.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_FLAGS()

    #define GTK_WIDGET_FLAGS(wid)		  (GTK_OBJECT_FLAGS (wid))

`GTK_WIDGET_FLAGS` has been deprecated since version 2.20 and should not be used in newly-written code.

Use the proper function to test individual states: `gtk_widget_get_app_paintable()`, `gtk_widget_get_can_default()`, `gtk_widget_get_can_focus()`, `gtk_widget_get_double_buffered()`, `gtk_widget_has_default()`, `gtk_widget_is_drawable()`, `gtk_widget_has_focus()`, `gtk_widget_has_grab()`, `gtk_widget_get_mapped()`, `gtk_widget_get_has_window()`, `gtk_widget_has_rc_style()`, `gtk_widget_get_realized()`, `gtk_widget_get_receives_default()`, `gtk_widget_get_sensitive()`, `gtk_widget_is_sensitive()`, `gtk_widget_is_toplevel()` or `gtk_widget_get_visible()`.

Returns the widget flags from `wid` .

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_TOPLEVEL()

    #define GTK_WIDGET_TOPLEVEL(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_TOPLEVEL) != 0)

`GTK_WIDGET_TOPLEVEL` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_is_toplevel()` instead.

Evaluates to `TRUE` if the widget is a toplevel widget.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_NO_WINDOW()

    #define GTK_WIDGET_NO_WINDOW(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_NO_WINDOW) != 0)

`GTK_WIDGET_NO_WINDOW` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_has_window()` instead.

Evaluates to `TRUE` if the widget doesn't have an own GdkWindow.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_REALIZED()

    #define GTK_WIDGET_REALIZED(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_REALIZED) != 0)

`GTK_WIDGET_REALIZED` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_realized()` instead.

Evaluates to `TRUE` if the widget is realized.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_MAPPED()

    #define GTK_WIDGET_MAPPED(wid)		  ((GTK_WIDGET_FLAGS (wid) & GTK_MAPPED) != 0)

`GTK_WIDGET_MAPPED` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_mapped()` instead.

Evaluates to `TRUE` if the widget is mapped.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_VISIBLE()

    #define GTK_WIDGET_VISIBLE(wid)		  ((GTK_WIDGET_FLAGS (wid) & GTK_VISIBLE) != 0)

`GTK_WIDGET_VISIBLE` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_visible()` instead.

Evaluates to `TRUE` if the widget is visible.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_DRAWABLE()

    #define GTK_WIDGET_DRAWABLE(wid)	  (GTK_WIDGET_VISIBLE (wid) && GTK_WIDGET_MAPPED (wid))

`GTK_WIDGET_DRAWABLE` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_is_drawable()` instead.

Evaluates to `TRUE` if the widget is mapped and visible.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_SENSITIVE()

    #define GTK_WIDGET_SENSITIVE(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_SENSITIVE) != 0)

`GTK_WIDGET_SENSITIVE` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_sensitive()` instead.

Evaluates to `TRUE` if the GTK_SENSITIVE flag has be set on the widget.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_PARENT_SENSITIVE()

    #define GTK_WIDGET_PARENT_SENSITIVE(wid)  ((GTK_WIDGET_FLAGS (wid) & GTK_PARENT_SENSITIVE) != 0)

`GTK_WIDGET_PARENT_SENSITIVE` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_sensitive()` on the parent widget instead.

Evaluates to `TRUE` if the GTK_PARENT_SENSITIVE flag has be set on the widget.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_IS_SENSITIVE()

    #define             GTK_WIDGET_IS_SENSITIVE(wid)

`GTK_WIDGET_IS_SENSITIVE` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_is_sensitive()` instead.

Evaluates to `TRUE` if the widget is effectively sensitive.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_CAN_FOCUS()

    #define GTK_WIDGET_CAN_FOCUS(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_CAN_FOCUS) != 0)

`GTK_WIDGET_CAN_FOCUS` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_can_focus()` instead.

Evaluates to `TRUE` if the widget is able to handle focus grabs.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_HAS_FOCUS()

    #define GTK_WIDGET_HAS_FOCUS(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_HAS_FOCUS) != 0)

`GTK_WIDGET_HAS_FOCUS` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_has_focus()` instead.

Evaluates to `TRUE` if the widget has grabbed the focus and no other widget has done so more recently.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_CAN_DEFAULT()

    #define GTK_WIDGET_CAN_DEFAULT(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_CAN_DEFAULT) != 0)

`GTK_WIDGET_CAN_DEFAULT` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_can_default()` instead.

Evaluates to `TRUE` if the widget is allowed to receive the default action via `gtk_widget_grab_default()`.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_RECEIVES_DEFAULT()

    #define GTK_WIDGET_RECEIVES_DEFAULT(wid)  ((GTK_WIDGET_FLAGS (wid) & GTK_RECEIVES_DEFAULT) != 0)

`GTK_WIDGET_RECEIVES_DEFAULT` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_receives_default()` instead.

Evaluates to `TRUE` if the widget when focused will receive the default action even if there is a different widget set as default.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_HAS_DEFAULT()

    #define GTK_WIDGET_HAS_DEFAULT(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_HAS_DEFAULT) != 0)

`GTK_WIDGET_HAS_DEFAULT` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_has_default()` instead.

Evaluates to `TRUE` if the widget currently is receiving the default action.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_HAS_GRAB()

    #define GTK_WIDGET_HAS_GRAB(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_HAS_GRAB) != 0)

`GTK_WIDGET_HAS_GRAB` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_has_grab()` instead.

Evaluates to `TRUE` if the widget is in the grab_widgets stack, and will be the preferred one for receiving events other than ones of cosmetic value.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_RC_STYLE()

    #define GTK_WIDGET_RC_STYLE(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_RC_STYLE) != 0)

`GTK_WIDGET_RC_STYLE` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_has_rc_style()` instead.

Evaluates to `TRUE` if the widget's style has been looked up through the rc mechanism.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_COMPOSITE_CHILD()

    #define GTK_WIDGET_COMPOSITE_CHILD(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_COMPOSITE_CHILD) != 0)

`GTK_WIDGET_COMPOSITE_CHILD` has been deprecated since version 2.20 and should not be used in newly-written code.

Use the “composite-child” property instead.

Evaluates to `TRUE` if the widget is a composite child of its parent.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_APP_PAINTABLE()

    #define GTK_WIDGET_APP_PAINTABLE(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_APP_PAINTABLE) != 0)

`GTK_WIDGET_APP_PAINTABLE` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_app_paintable()` instead.

Evaluates to `TRUE` if the GTK_APP_PAINTABLE flag has been set on the widget.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_DOUBLE_BUFFERED()

    #define GTK_WIDGET_DOUBLE_BUFFERED(wid)	  ((GTK_WIDGET_FLAGS (wid) & GTK_DOUBLE_BUFFERED) != 0)

`GTK_WIDGET_DOUBLE_BUFFERED` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_double_buffered()` instead.

Evaluates to `TRUE` if the GTK_DOUBLE_BUFFERED flag has been set on the widget.

#### Parameters

wid | a GtkWidget. |

### GTK_WIDGET_SET_FLAGS()

    #define GTK_WIDGET_SET_FLAGS(wid,flag)	  G_STMT_START{ (GTK_WIDGET_FLAGS (wid) |= (flag)); }G_STMT_END

`GTK_WIDGET_SET_FLAGS` has been deprecated since version 2.22 and should not be used in newly-written code.

Use the proper function instead: `gtk_widget_set_app_paintable()`, `gtk_widget_set_can_default()`, `gtk_widget_set_can_focus()`, `gtk_widget_set_double_buffered()`, `gtk_widget_set_has_window()`, `gtk_widget_set_mapped()`, `gtk_widget_set_no_show_all()`, `gtk_widget_set_realized()`, `gtk_widget_set_receives_default()`, `gtk_widget_set_sensitive()` or `gtk_widget_set_visible()`.

Turns on certain widget flags.

#### Parameters

wid | a GtkWidget. |
flag | the flags to set. |

### GTK_WIDGET_UNSET_FLAGS()

    #define GTK_WIDGET_UNSET_FLAGS(wid,flag)  G_STMT_START{ (GTK_WIDGET_FLAGS (wid) &= ~(flag)); }G_STMT_END

`GTK_WIDGET_UNSET_FLAGS` has been deprecated since version 2.22 and should not be used in newly-written code.

Use the proper function instead. See `GTK_WIDGET_SET_FLAGS()`.

Turns off certain widget flags.

#### Parameters

wid | a GtkWidget. |
flag | the flags to unset. |

### GtkCallback ()

    void
    (*GtkCallback) (GtkWidget *widget,
                    gpointer data);

The type of the callback functions used for e.g. iterating over the children of a container, see `gtk_container_foreach()`.

#### Parameters

widget | the widget to operate on |
data | user-supplied data |

### gtk_widget_new ()

    GtkWidget *
    gtk_widget_new (GType type,
                    const gchar *first_property_name,
                    ...);

This is a convenience function for creating a widget and setting its properties in one go. For example you might write: `gtk_widget_new (GTK_TYPE_LABEL, "label", "Hello World", "xalign", 0.0, NULL)` to create a left-aligned label. Equivalent to `g_object_new()`, but returns a widget so you don't have to cast the object yourself.

#### Parameters

type | type ID of the widget to create |
first_property_name | name of first property to set |
Varargs | value of first property, followed by more properties, `NULL`-terminated |

#### Returns

a new GtkWidget of type `widget_type`

### gtk_widget_ref ()

    GtkWidget *
    gtk_widget_ref (GtkWidget *widget);

`gtk_widget_ref` has been deprecated since version 2.12 and should not be used in newly-written code.

Use `g_object_ref()` instead.

Adds a reference to a widget. This function is exactly the same as calling `g_object_ref()`, and exists mostly for historical reasons. It can still be convenient to avoid casting a widget to a GObject, it saves a small amount of typing.

#### Parameters

widget | a GtkWidget |

#### Returns

the widget that was referenced

### gtk_widget_unref ()

    void
    gtk_widget_unref (GtkWidget *widget);

`gtk_widget_unref` has been deprecated since version 2.12 and should not be used in newly-written code.

Use `g_object_unref()` instead.

Inverse of `gtk_widget_ref()`. Equivalent to `g_object_unref()`.

#### Parameters

widget | a GtkWidget |

### gtk_widget_destroy ()

    void
    gtk_widget_destroy (GtkWidget *widget);

Destroys a widget. Equivalent to `gtk_object_destroy()`, except that you don't have to cast the widget to GtkObject. When a widget is destroyed, it will break any references it holds to other objects. If the widget is inside a container, the widget will be removed from the container. If the widget is a toplevel (derived from GtkWindow), it will be removed from the list of toplevels, and the reference GTK+ holds to it will be removed. Removing a widget from its container or the list of toplevels results in the widget being finalized, unless you've added additional references to the widget with `g_object_ref()`.

In most cases, only toplevel widgets (windows) require explicit destruction, because when you destroy a toplevel its children will be destroyed as well.

#### Parameters

widget | a GtkWidget |

### gtk_widget_destroyed ()

    void
    gtk_widget_destroyed (GtkWidget *widget,
                          GtkWidget **widget_pointer);

This function sets *`widget_pointer` to `NULL` if `widget_pointer` != `NULL`. It's intended to be used as a callback connected to the "destroy" signal of a widget. You connect `gtk_widget_destroyed()` as a signal handler, and pass the address of your widget variable as user data. Then when the widget is destroyed, the variable will be set to `NULL`. Useful for example to avoid multiple copies of the same dialog.

#### Parameters

widget | a GtkWidget |
widget_pointer | address of a variable that contains `widget` . | [inout][transfer none]

### gtk_widget_set ()

    void
    gtk_widget_set (GtkWidget *widget,
                    const gchar *first_property_name,
                    ...);

`gtk_widget_set` has been deprecated since version 2.0 and should not be used in newly-written code.

Use `g_object_set()` instead.

Precursor of `g_object_set()`.

#### Parameters

widget | a GtkWidget |
first_property_name | name of first property to set |
Varargs | value of first property, followed by more properties, `NULL`-terminated |

### gtk_widget_unparent ()

    void
    gtk_widget_unparent (GtkWidget *widget);

This function is only for use in widget implementations. Should be called by implementations of the remove method on GtkContainer, to dissociate a child from the container.

#### Parameters

widget | a GtkWidget |

### gtk_widget_show ()

    void
    gtk_widget_show (GtkWidget *widget);

Flags a widget to be displayed. Any widget that isn't shown will not appear on the screen. If you want to show all the widgets in a container, it's easier to call `gtk_widget_show_all()` on the container, instead of individually showing the widgets.

Remember that you have to show the containers containing a widget, in addition to the widget itself, before it will appear onscreen.

When a toplevel container is shown, it is immediately realized and mapped; other shown widgets are realized and mapped when their toplevel container is realized and mapped.

#### Parameters

widget | a GtkWidget |

### gtk_widget_show_now ()

    void
    gtk_widget_show_now (GtkWidget *widget);

Shows a widget. If the widget is an unmapped toplevel widget (i.e. a GtkWindow that has not yet been shown), enter the main loop and wait for the window to actually be mapped. Be careful; because the main loop is running, anything can happen during this function.

#### Parameters

widget | a GtkWidget |

### gtk_widget_hide ()

    void
    gtk_widget_hide (GtkWidget *widget);

Reverses the effects of `gtk_widget_show()`, causing the widget to be hidden (invisible to the user).

#### Parameters

widget | a GtkWidget |

### gtk_widget_show_all ()

    void
    gtk_widget_show_all (GtkWidget *widget);

Recursively shows a widget, and any child widgets (if the widget is a container).

#### Parameters

widget | a GtkWidget |

### gtk_widget_hide_all ()

    void
    gtk_widget_hide_all (GtkWidget *widget);

`gtk_widget_hide_all` has been deprecated since version 2.24 and should not be used in newly-written code.

Use `gtk_widget_hide()` instead.

Recursively hides a widget and any child widgets.

#### Parameters

widget | a GtkWidget |

### gtk_widget_map ()

    void
    gtk_widget_map (GtkWidget *widget);

This function is only for use in widget implementations. Causes a widget to be mapped if it isn't already.

#### Parameters

widget | a GtkWidget |

### gtk_widget_unmap ()

    void
    gtk_widget_unmap (GtkWidget *widget);

This function is only for use in widget implementations. Causes a widget to be unmapped if it's currently mapped.

#### Parameters

widget | a GtkWidget |

### gtk_widget_realize ()

    void
    gtk_widget_realize (GtkWidget *widget);

Creates the GDK (windowing system) resources associated with a widget. For example, `widget->window` will be created when a widget is realized. Normally realization happens implicitly; if you show a widget and all its parent containers, then the widget will be realized and mapped automatically.

Realizing a widget requires all the widget's parent widgets to be realized; calling `gtk_widget_realize()` realizes the widget's parents in addition to `widget` itself. If a widget is not yet inside a toplevel window when you realize it, bad things will happen.

This function is primarily used in widget implementations, and isn't very useful otherwise. Many times when you think you might need it, a better approach is to connect to a signal that will be called after the widget is realized automatically, such as GtkWidget::expose-event. Or simply `g_signal_connect()` to the GtkWidget::realize signal.

#### Parameters

widget | a GtkWidget |

### gtk_widget_unrealize ()

    void
    gtk_widget_unrealize (GtkWidget *widget);

This function is only useful in widget implementations. Causes a widget to be unrealized (frees all GDK resources associated with the widget, such as `widget->window` ).

#### Parameters

widget | a GtkWidget |

### gtk_widget_queue_draw ()

    void
    gtk_widget_queue_draw (GtkWidget *widget);

Equivalent to calling `gtk_widget_queue_draw_area()` for the entire area of a widget.

#### Parameters

widget | a GtkWidget |

### gtk_widget_queue_resize ()

    void
    gtk_widget_queue_resize (GtkWidget *widget);

`gtk_widget_queue_resize` is deprecated and should not be used in newly-written code.

This function is only for use in widget implementations. Flags a widget to have its size renegotiated; should be called when a widget for some reason has a new size request. For example, when you change the text in a GtkLabel, GtkLabel queues a resize to ensure there's enough space for the new text.

#### Parameters

widget | a GtkWidget |

### gtk_widget_queue_resize_no_redraw ()

    void
    gtk_widget_queue_resize_no_redraw (GtkWidget *widget);

This function works like `gtk_widget_queue_resize()`, except that the widget is not invalidated.

#### Parameters

widget | a GtkWidget |

Since: 2.4

### gtk_widget_draw ()

    void
    gtk_widget_draw (GtkWidget *widget,
                     const GdkRectangle *area);

`gtk_widget_draw` is deprecated and should not be used in newly-written code.

In GTK+ 1.2, this function would immediately render the region `area` of a widget, by invoking the virtual draw method of a widget. In GTK+ 2.0, the draw method is gone, and instead `gtk_widget_draw()` simply invalidates the specified region of the widget, then updates the invalid region of the widget immediately. Usually you don't want to update the region immediately for performance reasons, so in general `gtk_widget_queue_draw_area()` is a better choice if you want to draw a region of a widget.

#### Parameters

widget | a GtkWidget |
area | area to draw |

### gtk_widget_size_request ()

    void
    gtk_widget_size_request (GtkWidget *widget,
                             GtkRequisition *requisition);

`gtk_widget_size_request` is deprecated and should not be used in newly-written code.

This function is typically used when implementing a GtkContainer subclass. Obtains the preferred size of a widget. The container uses this information to arrange its child widgets and decide what size allocations to give them with `gtk_widget_size_allocate()`.

You can also call this function from an application, with some caveats. Most notably, getting a size request requires the widget to be associated with a screen, because font information may be needed. Multihead-aware applications should keep this in mind.

Also remember that the size request is not necessarily the size a widget will actually be allocated.

See also `gtk_widget_get_child_requisition()`.

#### Parameters

widget | a GtkWidget |
requisition | a GtkRequisition to be filled in |

### gtk_widget_get_child_requisition ()

    void
    gtk_widget_get_child_requisition (GtkWidget *widget,
                                      GtkRequisition *requisition);

This function is only for use in widget implementations. Obtains `widget->requisition` , unless someone has forced a particular geometry on the widget (e.g. with `gtk_widget_set_size_request()`), in which case it returns that geometry instead of the widget's requisition.

This function differs from `gtk_widget_size_request()` in that it retrieves the last size request value from `widget->requisition` , while `gtk_widget_size_request()` actually calls the "size_request" method on `widget` to compute the size request and fill in `widget->requisition` , and only then returns `widget->requisition` .

Because this function does not call the "size_request" method, it can only be used when you know that `widget->requisition` is up-to-date, that is, `gtk_widget_size_request()` has been called since the last time a resize was queued. In general, only container implementations have this information; applications should use `gtk_widget_size_request()`.

#### Parameters

widget | a GtkWidget |
requisition | a GtkRequisition to be filled in |

### gtk_widget_size_allocate ()

    void
    gtk_widget_size_allocate (GtkWidget *widget,
                              GtkAllocation *allocation);

This function is only used by GtkContainer subclasses, to assign a size and position to their child widgets.

#### Parameters

widget | a GtkWidget |
allocation | position and size to be allocated to `widget` |

### gtk_widget_add_accelerator ()

    void
    gtk_widget_add_accelerator (GtkWidget *widget,
                                const gchar *accel_signal,
                                GtkAccelGroup *accel_group,
                                guint accel_key,
                                GdkModifierType accel_mods,
                                GtkAccelFlags accel_flags);

Installs an accelerator for this `widget` in `accel_group` that causes `accel_signal` to be emitted if the accelerator is activated. The `accel_group` needs to be added to the widget's toplevel via `gtk_window_add_accel_group()`, and the signal must be of type `G_RUN_ACTION`. Accelerators added through this function are not user changeable during runtime. If you want to support accelerators that can be changed by the user, use `gtk_accel_map_add_entry()` and `gtk_widget_set_accel_path()` or `gtk_menu_item_set_accel_path()` instead.

#### Parameters

widget | widget to install an accelerator on |
accel_signal | widget signal to emit on accelerator activation |
accel_group | accel group for this widget, added to its toplevel |
accel_key | GDK keyval of the accelerator |
accel_mods | modifier key combination of the accelerator |
accel_flags | flag accelerators, e.g. `GTK_ACCEL_VISIBLE` |

### gtk_widget_remove_accelerator ()

    gboolean
    gtk_widget_remove_accelerator (GtkWidget *widget,
                                   GtkAccelGroup *accel_group,
                                   guint accel_key,
                                   GdkModifierType accel_mods);

Removes an accelerator from `widget` , previously installed with `gtk_widget_add_accelerator()`.

#### Parameters

widget | widget to install an accelerator on |
accel_group | accel group for this widget |
accel_key | GDK keyval of the accelerator |
accel_mods | modifier key combination of the accelerator |
returns | whether an accelerator was installed and could be removed |

### gtk_widget_set_accel_path ()

    void
    gtk_widget_set_accel_path (GtkWidget *widget,
                               const gchar *accel_path,
                               GtkAccelGroup *accel_group);

Given an accelerator group, `accel_group` , and an accelerator path, `accel_path` , sets up an accelerator in `accel_group` so whenever the key binding that is defined for `accel_path` is pressed, `widget` will be activated. This removes any accelerators (for any accelerator group) installed by previous calls to `gtk_widget_set_accel_path()`. Associating accelerators with paths allows them to be modified by the user and the modifications to be saved for future use. (See `gtk_accel_map_save()`.)

This function is a low level function that would most likely be used by a menu creation system like GtkUIManager. If you use GtkUIManager, setting up accelerator paths will be done automatically.

Even when you you aren't using GtkUIManager, if you only want to set up accelerators on menu items `gtk_menu_item_set_accel_path()` provides a somewhat more convenient interface.

Note that `accel_path` string will be stored in a GQuark. Therefore, if you pass a static string, you can save some memory by interning it first with `g_intern_static_string()`.

#### Parameters

widget | a GtkWidget |
accel_path | path used to look up the accelerator. | [allow-none]
accel_group | a GtkAccelGroup. | [allow-none]

### gtk_widget_list_accel_closures ()

    GList *
    gtk_widget_list_accel_closures (GtkWidget *widget);

Lists the closures used by `widget` for accelerator group connections with `gtk_accel_group_connect_by_path()` or `gtk_accel_group_connect()`. The closures can be used to monitor accelerator changes on `widget` , by connecting to the `GtkAccelGroup` ::accel-changed signal of the GtkAccelGroup of a closure which can be found out with `gtk_accel_group_from_accel_closure()`.

#### Parameters

widget | widget to list accelerator closures for |

#### Returns

a newly allocated GList of closures.

[transfer container][element-type GClosure]

### gtk_widget_can_activate_accel ()

    gboolean
    gtk_widget_can_activate_accel (GtkWidget *widget,
                                   guint signal_id);

Determines whether an accelerator that activates the signal identified by `signal_id` can currently be activated. This is done by emitting the “can-activate-accel” signal on `widget` ; if the signal isn't overridden by a handler or in a derived widget, then the default check is that the widget must be sensitive, and the widget and all its ancestors mapped.

#### Parameters

widget | a GtkWidget |
signal_id | the ID of a signal installed on `widget` |

#### Returns

`TRUE` if the accelerator can be activated.

Since: 2.4

### gtk_widget_event ()

    gboolean
    gtk_widget_event (GtkWidget *widget,
                      GdkEvent *event);

Rarely-used function. This function is used to emit the event signals on a widget (those signals should never be emitted without using this function to do so). If you want to synthesize an event though, don't use this function; instead, use `gtk_main_do_event()` so the event will behave as if it were in the event queue. Don't synthesize expose events; instead, use `gdk_window_invalidate_rect()` to invalidate a region of the window.

#### Parameters

widget | a GtkWidget |
event | a GdkEvent |

#### Returns

return from the event signal emission (`TRUE` if the event was handled)

### gtk_widget_activate ()

    gboolean
    gtk_widget_activate (GtkWidget *widget);

For widgets that can be "activated" (buttons, menu items, etc.) this function activates them. Activation is what happens when you press Enter on a widget during key navigation. If `widget` isn't activatable, the function returns `FALSE`.

#### Parameters

widget | a GtkWidget that's activatable |

#### Returns

`TRUE` if the widget was activatable

### gtk_widget_reparent ()

    void
    gtk_widget_reparent (GtkWidget *widget,
                         GtkWidget *new_parent);

Moves a widget from one GtkContainer to another, handling reference count issues to avoid destroying the widget.

#### Parameters

widget | a GtkWidget |
new_parent | a GtkContainer to move the widget into |

### gtk_widget_intersect ()

    gboolean
    gtk_widget_intersect (GtkWidget *widget,
                          const GdkRectangle *area,
                          GdkRectangle *intersection);

Computes the intersection of a `widget` 's area and `area` , storing the intersection in `intersection` , and returns `TRUE` if there was an intersection. `intersection` may be `NULL` if you're only interested in whether there was an intersection.

#### Parameters

widget | a GtkWidget |
area | a rectangle |
intersection | rectangle to store intersection of `widget` and `area` |

#### Returns

`TRUE` if there was an intersection

### gtk_widget_is_focus ()

    gboolean
    gtk_widget_is_focus (GtkWidget *widget);

Determines if the widget is the focus widget within its toplevel. (This does not mean that the `HAS_FOCUS` flag is necessarily set; `HAS_FOCUS` will only be set if the toplevel widget additionally has the global input focus.)

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget is the focus widget.

### gtk_widget_grab_focus ()

    void
    gtk_widget_grab_focus (GtkWidget *widget);

Causes `widget` to have the keyboard focus for the GtkWindow it's inside. `widget` must be a focusable widget, such as a GtkEntry; something like GtkFrame won't work.

More precisely, it must have the `GTK_CAN_FOCUS` flag set. Use `gtk_widget_set_can_focus()` to modify that flag.

The widget also needs to be realized and mapped. This is indicated by the related signals. Grabbing the focus immediately after creating the widget will likely fail and cause critical warnings.

#### Parameters

widget | a GtkWidget |

### gtk_widget_grab_default ()

    void
    gtk_widget_grab_default (GtkWidget *widget);

Causes `widget` to become the default widget. `widget` must have the `GTK_CAN_DEFAULT` flag set; typically you have to set this flag yourself by calling `gtk_widget_set_can_default (`widget` , `TRUE`)`. The default widget is activated when the user presses Enter in a window. Default widgets must be activatable, that is, `gtk_widget_activate()` should affect them.

#### Parameters

widget | a GtkWidget |

### gtk_widget_set_name ()

    void
    gtk_widget_set_name (GtkWidget *widget,
                         const gchar *name);

Widgets can be named, which allows you to refer to them from a gtkrc file. You can apply a style to widgets with a particular name in the gtkrc file. See the documentation for gtkrc files (on the same page as the docs for GtkRcStyle).

Note that widget names are separated by periods in paths (see `gtk_widget_path()`), so names with embedded periods may cause confusion.

#### Parameters

widget | a GtkWidget |
name | name for the widget |

### gtk_widget_get_name ()

    const gchar *
    gtk_widget_get_name (GtkWidget *widget);

Retrieves the name of a widget. See `gtk_widget_set_name()` for the significance of widget names.

#### Parameters

widget | a GtkWidget |

#### Returns

name of the widget. This string is owned by GTK+ and should not be modified or freed

### gtk_widget_set_state ()

    void
    gtk_widget_set_state (GtkWidget *widget,
                          GtkStateType state);

This function is for use in widget implementations. Sets the state of a widget (insensitive, prelighted, etc.) Usually you should set the state using wrapper functions such as `gtk_widget_set_sensitive()`.

#### Parameters

widget | a GtkWidget |
state | new state for `widget` |

### gtk_widget_set_sensitive ()

    void
    gtk_widget_set_sensitive (GtkWidget *widget,
                              gboolean sensitive);

Sets the sensitivity of a widget. A widget is sensitive if the user can interact with it. Insensitive widgets are "grayed out" and the user can't interact with them. Insensitive widgets are known as "inactive", "disabled", or "ghosted" in some other toolkits.

#### Parameters

widget | a GtkWidget |
sensitive | `TRUE` to make the widget sensitive |

### gtk_widget_set_parent ()

    void
    gtk_widget_set_parent (GtkWidget *widget,
                           GtkWidget *parent);

This function is useful only when implementing subclasses of GtkContainer. Sets the container as the parent of `widget` , and takes care of some details such as updating the state and style of the child to reflect its new location. The opposite function is `gtk_widget_unparent()`.

#### Parameters

widget | a GtkWidget |
parent | parent container |

### gtk_widget_set_parent_window ()

    void
    gtk_widget_set_parent_window (GtkWidget *widget,
                                  GdkWindow *parent_window);

Sets a non default parent window for `widget` .

#### Parameters

widget | a GtkWidget. |
parent_window | the new parent window. |

### gtk_widget_get_parent_window ()

    GdkWindow *
    gtk_widget_get_parent_window (GtkWidget *widget);

Gets `widget` 's parent window.

#### Parameters

widget | a GtkWidget. |

#### Returns

the parent window of `widget` .

[transfer none]

### gtk_widget_set_uposition ()

    void
    gtk_widget_set_uposition (GtkWidget *widget,
                              gint x,
                              gint y);

`gtk_widget_set_uposition` is deprecated and should not be used in newly-written code.

Sets the position of a widget. The funny "u" in the name comes from the "user position" hint specified by the X Window System, and exists for legacy reasons. This function doesn't work if a widget is inside a container; it's only really useful on GtkWindow.

Don't use this function to center dialogs over the main application window; most window managers will do the centering on your behalf if you call `gtk_window_set_transient_for()`, and it's really not possible to get the centering to work correctly in all cases from application code. But if you insist, use `gtk_window_set_position()` to set GTK_WIN_POS_CENTER_ON_PARENT, don't do the centering manually.

Note that although `x` and `y` can be individually unset, the position is not honoured unless both `x` and `y` are set.

#### Parameters

widget | a GtkWidget |
x | x position; -1 to unset x; -2 to leave x unchanged |
y | y position; -1 to unset y; -2 to leave y unchanged |

### gtk_widget_set_usize ()

    void
    gtk_widget_set_usize (GtkWidget *widget,
                          gint width,
                          gint height);

`gtk_widget_set_usize` has been deprecated since version 2.2 and should not be used in newly-written code.

Use `gtk_widget_set_size_request()` instead.

Sets the minimum size of a widget; that is, the widget's size request will be `width` by `height` . You can use this function to force a widget to be either larger or smaller than it is. The strange "usize" name dates from the early days of GTK+, and derives from X Window System terminology. In many cases, `gtk_window_set_default_size()` is a better choice for toplevel windows than this function; setting the default size will still allow users to shrink the window. Setting the usize will force them to leave the window at least as large as the usize. When dealing with window sizes, `gtk_window_set_geometry_hints()` can be a useful function as well.

Note the inherent danger of setting any fixed size - themes, translations into other languages, different fonts, and user action can all change the appropriate size for a given widget. So, it's basically impossible to hardcode a size that will always be correct.

#### Parameters

widget | a GtkWidget |
width | minimum width, or -1 to unset |
height | minimum height, or -1 to unset |

### gtk_widget_set_events ()

    void
    gtk_widget_set_events (GtkWidget *widget,
                           gint events);

Sets the event mask (see GdkEventMask) for a widget. The event mask determines which events a widget will receive. Keep in mind that different widgets have different default event masks, and by changing the event mask you may disrupt a widget's functionality, so be careful. This function must be called while a widget is unrealized. Consider `gtk_widget_add_events()` for widgets that are already realized, or if you want to preserve the existing event mask. This function can't be used with GTK_NO_WINDOW widgets; to get events on those widgets, place them inside a GtkEventBox and receive events on the event box.

#### Parameters

widget | a GtkWidget |
events | event mask |

### gtk_widget_add_events ()

    void
    gtk_widget_add_events (GtkWidget *widget,
                           gint events);

Adds the events in the bitfield `events` to the event mask for `widget` . See `gtk_widget_set_events()` for details.

#### Parameters

widget | a GtkWidget |
events | an event mask, see GdkEventMask |

### gtk_widget_set_extension_events ()

    void
    gtk_widget_set_extension_events (GtkWidget *widget,
                                     GdkExtensionMode mode);

Sets the extension events mask to `mode` . See GdkExtensionMode and `gdk_input_set_extension_events()`.

#### Parameters

widget | a GtkWidget |
mode | bitfield of extension events to receive |

### gtk_widget_get_extension_events ()

    GdkExtensionMode
    gtk_widget_get_extension_events (GtkWidget *widget);

Retrieves the extension events the widget will receive; see `gdk_input_set_extension_events()`.

#### Parameters

widget | a GtkWidget |

#### Returns

extension events for `widget`

### gtk_widget_get_toplevel ()

    GtkWidget *
    gtk_widget_get_toplevel (GtkWidget *widget);

This function returns the topmost widget in the container hierarchy `widget` is a part of. If `widget` has no parent widgets, it will be returned as the topmost widget. No reference will be added to the returned widget; it should not be unreferenced.

Note the difference in behavior vs. `gtk_widget_get_ancestor()`; `gtk_widget_get_ancestor (widget, GTK_TYPE_WINDOW)` would return `NULL` if `widget` wasn't inside a toplevel window, and if the window was inside a GtkWindow-derived widget which was in turn inside the toplevel GtkWindow. While the second case may seem unlikely, it actually happens when a GtkPlug is embedded inside a GtkSocket within the same application.

To reliably find the toplevel GtkWindow, use `gtk_widget_get_toplevel()` and check if the `TOPLEVEL` flags is set on the result.

    1
    2
    3
    4
    5
    GtkWidget *toplevel = gtk_widget_get_toplevel (widget);
    if (gtk_widget_is_toplevel (toplevel))
      {
        /* Perform action on toplevel. */
      }

#### Parameters

widget | a GtkWidget |

#### Returns

the topmost ancestor of `widget` , or `widget` itself if there's no ancestor.

[transfer none]

### gtk_widget_get_ancestor ()

    GtkWidget *
    gtk_widget_get_ancestor (GtkWidget *widget,
                             GType widget_type);

Gets the first ancestor of `widget` with type `widget_type` . For example, `gtk_widget_get_ancestor (widget, GTK_TYPE_BOX)` gets the first GtkBox that's an ancestor of `widget` . No reference will be added to the returned widget; it should not be unreferenced. See note about checking for a toplevel GtkWindow in the docs for `gtk_widget_get_toplevel()`.

Note that unlike `gtk_widget_is_ancestor()`, `gtk_widget_get_ancestor()` considers `widget` to be an ancestor of itself.

#### Parameters

widget | a GtkWidget |
widget_type | ancestor type |

#### Returns

the ancestor widget, or `NULL` if not found.

[transfer none]

### gtk_widget_get_colormap ()

    GdkColormap *
    gtk_widget_get_colormap (GtkWidget *widget);

Gets the colormap that will be used to render `widget` . No reference will be added to the returned colormap; it should not be unreferenced.

#### Parameters

widget | a GtkWidget |

#### Returns

the colormap used by `widget` .

[transfer none]

### gtk_widget_set_colormap ()

    void
    gtk_widget_set_colormap (GtkWidget *widget,
                             GdkColormap *colormap);

Sets the colormap for the widget to the given value. Widget must not have been previously realized. This probably should only be used from an ``init()`` function (i.e. from the constructor for the widget).

#### Parameters

widget | a GtkWidget |
colormap | a colormap |

### gtk_widget_get_visual ()

    GdkVisual *
    gtk_widget_get_visual (GtkWidget *widget);

Gets the visual that will be used to render `widget` .

#### Parameters

widget | a GtkWidget |

#### Returns

the visual for `widget` .

[transfer none]

### gtk_widget_get_events ()

    gint
    gtk_widget_get_events (GtkWidget *widget);

Returns the event mask for the widget (a bitfield containing flags from the GdkEventMask enumeration). These are the events that the widget will receive.

#### Parameters

widget | a GtkWidget |

#### Returns

event mask for `widget`

### gtk_widget_get_pointer ()

    void
    gtk_widget_get_pointer (GtkWidget *widget,
                            gint *x,
                            gint *y);

Obtains the location of the mouse pointer in widget coordinates. Widget coordinates are a bit odd; for historical reasons, they are defined as `widget->window` coordinates for widgets that are not GTK_NO_WINDOW widgets, and are relative to `widget->allocation.x` , `widget->allocation.y` for widgets that are GTK_NO_WINDOW widgets.

#### Parameters

widget | a GtkWidget |
x | return location for the X coordinate, or `NULL`. | [out][allow-none]
y | return location for the Y coordinate, or `NULL`. | [out][allow-none]

### gtk_widget_is_ancestor ()

    gboolean
    gtk_widget_is_ancestor (GtkWidget *widget,
                            GtkWidget *ancestor);

Determines whether `widget` is somewhere inside `ancestor` , possibly with intermediate containers.

#### Parameters

widget | a GtkWidget |
ancestor | another GtkWidget |

#### Returns

`TRUE` if `ancestor` contains `widget` as a child, grandchild, great grandchild, etc.

### gtk_widget_translate_coordinates ()

    gboolean
    gtk_widget_translate_coordinates (GtkWidget *src_widget,
                                      GtkWidget *dest_widget,
                                      gint src_x,
                                      gint src_y,
                                      gint *dest_x,
                                      gint *dest_y);

Translate coordinates relative to `src_widget` 's allocation to coordinates relative to `dest_widget` 's allocations. In order to perform this operation, both widgets must be realized, and must share a common toplevel.

#### Parameters

src_widget | a GtkWidget |
dest_widget | a GtkWidget |
src_x | X position relative to `src_widget` |
src_y | Y position relative to `src_widget` |
dest_x | location to store X position relative to `dest_widget` . | [out]
dest_y | location to store Y position relative to `dest_widget` . | [out]

#### Returns

`FALSE` if either widget was not realized, or there was no common ancestor. In this case, nothing is stored in *`dest_x` and *`dest_y` . Otherwise `TRUE`.

### gtk_widget_hide_on_delete ()

    gboolean
    gtk_widget_hide_on_delete (GtkWidget *widget);

Utility function; intended to be connected to the “delete-event” signal on a GtkWindow. The function calls `gtk_widget_hide()` on its argument, then returns `TRUE`. If connected to ::delete-event, the result is that clicking the close button for a window (on the window frame, top right corner usually) will hide but not destroy the window. By default, GTK+ destroys windows when ::delete-event is received.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE`

### gtk_widget_set_style ()

    void
    gtk_widget_set_style (GtkWidget *widget,
                          GtkStyle *style);

Sets the GtkStyle for a widget (`widget->style` ). You probably don't want to use this function; it interacts badly with themes, because themes work by replacing the GtkStyle. Instead, use `gtk_widget_modify_style()`.

#### Parameters

widget | a GtkWidget |
style | a GtkStyle, or `NULL` to remove the effect of a previous `gtk_widget_set_style()` and go back to the default style. | [allow-none]

### gtk_widget_set_rc_style()

    #define gtk_widget_set_rc_style(widget)          (gtk_widget_set_style (widget, NULL))

`gtk_widget_set_rc_style` has been deprecated since version 2.0 and should not be used in newly-written code.

Use `gtk_widget_set_style()` with a `NULL` `style` argument instead.

Equivalent to `gtk_widget_set_style (widget, NULL)`.

#### Parameters

widget | a GtkWidget. |

### gtk_widget_ensure_style ()

    void
    gtk_widget_ensure_style (GtkWidget *widget);

Ensures that `widget` has a style (`widget->style` ). Not a very useful function; most of the time, if you want the style, the widget is realized, and realized widgets are guaranteed to have a style already.

#### Parameters

widget | a GtkWidget |

### gtk_widget_get_style ()

    GtkStyle *
    gtk_widget_get_style (GtkWidget *widget);

Simply an accessor function that returns `widget->style` .

#### Parameters

widget | a GtkWidget |

#### Returns

the widget's GtkStyle.

[transfer none]

### gtk_widget_restore_default_style()

    #define gtk_widget_restore_default_style(widget) (gtk_widget_set_style (widget, NULL))

`gtk_widget_restore_default_style` has been deprecated since version 2.0 and should not be used in newly-written code.

Use `gtk_widget_set_style()` with a `NULL` `style` argument instead.

Equivalent to `gtk_widget_set_style (widget, NULL)`.

#### Parameters

widget | a GtkWidget. |

### gtk_widget_reset_rc_styles ()

    void
    gtk_widget_reset_rc_styles (GtkWidget *widget);

Reset the styles of `widget` and all descendents, so when they are looked up again, they get the correct values for the currently loaded RC file settings.

This function is not useful for applications.

#### Parameters

widget | a GtkWidget. |

### gtk_widget_push_colormap ()

    void
    gtk_widget_push_colormap (GdkColormap *cmap);

Pushes `cmap` onto a global stack of colormaps; the topmost colormap on the stack will be used to create all widgets. Remove `cmap` with `gtk_widget_pop_colormap()`. There's little reason to use this function.

#### Parameters

cmap | a GdkColormap |

### gtk_widget_pop_colormap ()

    void
    gtk_widget_pop_colormap (void);

Removes a colormap pushed with `gtk_widget_push_colormap()`.

### gtk_widget_set_default_colormap ()

    void
    gtk_widget_set_default_colormap (GdkColormap *colormap);

Sets the default colormap to use when creating widgets. `gtk_widget_push_colormap()` is a better function to use if you only want to affect a few widgets, rather than all widgets.

#### Parameters

colormap | a GdkColormap |

### gtk_widget_get_default_style ()

    GtkStyle *
    gtk_widget_get_default_style (void);

Returns the default style used by all widgets initially.

#### Returns

the default style. This GtkStyle object is owned by GTK+ and should not be modified or freed.

[transfer none]

### gtk_widget_get_default_colormap ()

    GdkColormap *
    gtk_widget_get_default_colormap (void);

Obtains the default colormap used to create widgets.

#### Returns

default widget colormap.

[transfer none]

### gtk_widget_get_default_visual ()

    GdkVisual *
    gtk_widget_get_default_visual (void);

Obtains the visual of the default colormap. Not really useful; used to be useful before `gdk_colormap_get_visual()` existed.

#### Returns

visual of the default colormap.

[transfer none]

### gtk_widget_set_direction ()

    void
    gtk_widget_set_direction (GtkWidget *widget,
                              GtkTextDirection dir);

Sets the reading direction on a particular widget. This direction controls the primary direction for widgets containing text, and also the direction in which the children of a container are packed. The ability to set the direction is present in order so that correct localization into languages with right-to-left reading directions can be done. Generally, applications will let the default reading direction present, except for containers where the containers are arranged in an order that is explicitely visual rather than logical (such as buttons for text justification).

If the direction is set to `GTK_TEXT_DIR_NONE`, then the value set by `gtk_widget_set_default_direction()` will be used.

#### Parameters

widget | a GtkWidget |
dir | the new direction |

### gtk_widget_get_direction ()

    GtkTextDirection
    gtk_widget_get_direction (GtkWidget *widget);

Gets the reading direction for a particular widget. See `gtk_widget_set_direction()`.

#### Parameters

widget | a GtkWidget |

#### Returns

the reading direction for the widget.

### gtk_widget_set_default_direction ()

    void
    gtk_widget_set_default_direction (GtkTextDirection dir);

Sets the default reading direction for widgets where the direction has not been explicitly set by `gtk_widget_set_direction()`.

#### Parameters

dir | the new default direction. This cannot be `GTK_TEXT_DIR_NONE`. |

### gtk_widget_get_default_direction ()

    GtkTextDirection
    gtk_widget_get_default_direction (void);

Obtains the current default reading direction. See `gtk_widget_set_default_direction()`.

#### Returns

the current default direction.

### gtk_widget_shape_combine_mask ()

    void
    gtk_widget_shape_combine_mask (GtkWidget *widget,
                                   GdkBitmap *shape_mask,
                                   gint offset_x,
                                   gint offset_y);

Sets a shape for this widget's GDK window. This allows for transparent windows etc., see `gdk_window_shape_combine_mask()` for more information.

#### Parameters

widget | a GtkWidget |
shape_mask | shape to be added, or `NULL` to remove an existing shape. | [allow-none]
offset_x | X position of shape mask with respect to `window` |
offset_y | Y position of shape mask with respect to `window` |

### gtk_widget_input_shape_combine_mask ()

    void
    gtk_widget_input_shape_combine_mask (GtkWidget *widget,
                                         GdkBitmap *shape_mask,
                                         gint offset_x,
                                         gint offset_y);

Sets an input shape for this widget's GDK window. This allows for windows which react to mouse click in a nonrectangular region, see `gdk_window_input_shape_combine_mask()` for more information.

#### Parameters

widget | a GtkWidget |
shape_mask | shape to be added, or `NULL` to remove an existing shape. | [allow-none]
offset_x | X position of shape mask with respect to `window` |
offset_y | Y position of shape mask with respect to `window` |

Since: 2.10

### gtk_widget_path ()

    void
    gtk_widget_path (GtkWidget *widget,
                     guint *path_length,
                     gchar **path,
                     gchar **path_reversed);

Obtains the full path to `widget` . The path is simply the name of a widget and all its parents in the container hierarchy, separated by periods. The name of a widget comes from `gtk_widget_get_name()`. Paths are used to apply styles to a widget in gtkrc configuration files. Widget names are the type of the widget by default (e.g. "GtkButton") or can be set to an application-specific value with `gtk_widget_set_name()`. By setting the name of a widget, you allow users or theme authors to apply styles to that specific widget in their gtkrc file. `path_reversed_p` fills in the path in reverse order, i.e. starting with `widget` 's name instead of starting with the name of `widget` 's outermost ancestor.

#### Parameters

widget | a GtkWidget |
path_length | location to store length of the path, or `NULL`. | [out][allow-none]
path | location to store allocated path string, or `NULL`. | [out][allow-none]
path_reversed | location to store allocated reverse path string, or `NULL`. | [out][allow-none]

### gtk_widget_class_path ()

    void
    gtk_widget_class_path (GtkWidget *widget,
                           guint *path_length,
                           gchar **path,
                           gchar **path_reversed);

Same as `gtk_widget_path()`, but always uses the name of a widget's type, never uses a custom name set with `gtk_widget_set_name()`.

#### Parameters

widget | a GtkWidget |
path_length | location to store the length of the class path, or `NULL`. | [out][allow-none]
path | location to store the class path as an allocated string, or `NULL`. | [out][allow-none]
path_reversed | location to store the reverse class path as an allocated string, or `NULL`. | [out][allow-none]

### gtk_widget_get_composite_name ()

    gchar *
    gtk_widget_get_composite_name (GtkWidget *widget);

Obtains the composite name of a widget.

#### Parameters

widget | a GtkWidget |

#### Returns

the composite name of `widget` , or `NULL` if `widget` is not a composite child. The string should be freed when it is no longer needed.

### gtk_widget_modify_style ()

    void
    gtk_widget_modify_style (GtkWidget *widget,
                             GtkRcStyle *style);

Modifies style values on the widget. Modifications made using this technique take precedence over style values set via an RC file, however, they will be overriden if a style is explicitely set on the widget using `gtk_widget_set_style()`. The GtkRcStyle structure is designed so each field can either be set or unset, so it is possible, using this function, to modify some style values and leave the others unchanged.

Note that modifications made with this function are not cumulative with previous calls to `gtk_widget_modify_style()` or with such functions as `gtk_widget_modify_fg()`. If you wish to retain previous values, you must first call `gtk_widget_get_modifier_style()`, make your modifications to the returned style, then call `gtk_widget_modify_style()` with that style. On the other hand, if you first call `gtk_widget_modify_style()`, subsequent calls to such functions `gtk_widget_modify_fg()` will have a cumulative effect with the initial modifications.

#### Parameters

widget | a GtkWidget |
style | the GtkRcStyle holding the style modifications |

### gtk_widget_get_modifier_style ()

    GtkRcStyle *
    gtk_widget_get_modifier_style (GtkWidget *widget);

Returns the current modifier style for the widget. (As set by `gtk_widget_modify_style()`.) If no style has previously set, a new GtkRcStyle will be created with all values unset, and set as the modifier style for the widget. If you make changes to this rc style, you must call `gtk_widget_modify_style()`, passing in the returned rc style, to make sure that your changes take effect.

Caution: passing the style back to `gtk_widget_modify_style()` will normally end up destroying it, because `gtk_widget_modify_style()` copies the passed-in style and sets the copy as the new modifier style, thus dropping any reference to the old modifier style. Add a reference to the modifier style if you want to keep it alive.

#### Parameters

widget | a GtkWidget |

#### Returns

the modifier style for the widget. This rc style is owned by the widget. If you want to keep a pointer to value this around, you must add a refcount using `g_object_ref()`.

[transfer none]

### gtk_widget_modify_fg ()

    void
    gtk_widget_modify_fg (GtkWidget *widget,
                          GtkStateType state,
                          const GdkColor *color);

Sets the foreground color for a widget in a particular state. All other style values are left untouched. See also `gtk_widget_modify_style()`.

#### Parameters

widget | a GtkWidget |
state | the state for which to set the foreground color |
color | the color to assign (does not need to be allocated), or `NULL` to undo the effect of previous calls to of `gtk_widget_modify_fg()`. | [allow-none]

### gtk_widget_modify_bg ()

    void
    gtk_widget_modify_bg (GtkWidget *widget,
                          GtkStateType state,
                          const GdkColor *color);

Sets the background color for a widget in a particular state. All other style values are left untouched. See also `gtk_widget_modify_style()`.

Note that "no window" widgets (which have the `GTK_NO_WINDOW` flag set) draw on their parent container's window and thus may not draw any background themselves. This is the case for e.g. GtkLabel. To modify the background of such widgets, you have to set the background color on their parent; if you want to set the background of a rectangular area around a label, try placing the label in a GtkEventBox widget and setting the background color on that.

#### Parameters

widget | a GtkWidget |
state | the state for which to set the background color |
color | the color to assign (does not need to be allocated), or `NULL` to undo the effect of previous calls to of `gtk_widget_modify_bg()`. | [allow-none]

### gtk_widget_modify_text ()

    void
    gtk_widget_modify_text (GtkWidget *widget,
                            GtkStateType state,
                            const GdkColor *color);

Sets the text color for a widget in a particular state. All other style values are left untouched. The text color is the foreground color used along with the base color (see `gtk_widget_modify_base()`) for widgets such as GtkEntry and GtkTextView. See also `gtk_widget_modify_style()`.

#### Parameters

widget | a GtkWidget |
state | the state for which to set the text color |
color | the color to assign (does not need to be allocated), or `NULL` to undo the effect of previous calls to of `gtk_widget_modify_text()`. | [allow-none]

### gtk_widget_modify_base ()

    void
    gtk_widget_modify_base (GtkWidget *widget,
                            GtkStateType state,
                            const GdkColor *color);

Sets the base color for a widget in a particular state. All other style values are left untouched. The base color is the background color used along with the text color (see `gtk_widget_modify_text()`) for widgets such as GtkEntry and GtkTextView. See also `gtk_widget_modify_style()`.

Note that "no window" widgets (which have the `GTK_NO_WINDOW` flag set) draw on their parent container's window and thus may not draw any background themselves. This is the case for e.g. GtkLabel. To modify the background of such widgets, you have to set the base color on their parent; if you want to set the background of a rectangular area around a label, try placing the label in a GtkEventBox widget and setting the base color on that.

#### Parameters

widget | a GtkWidget |
state | the state for which to set the base color |
color | the color to assign (does not need to be allocated), or `NULL` to undo the effect of previous calls to of `gtk_widget_modify_base()`. | [allow-none]

### gtk_widget_modify_font ()

    void
    gtk_widget_modify_font (GtkWidget *widget,
                            PangoFontDescription *font_desc);

Sets the font to use for a widget. All other style values are left untouched. See also `gtk_widget_modify_style()`.

#### Parameters

widget | a GtkWidget |
font_desc | the font description to use, or `NULL` to undo the effect of previous calls to `gtk_widget_modify_font()`. | [allow-none]

### gtk_widget_modify_cursor ()

    void
    gtk_widget_modify_cursor (GtkWidget *widget,
                              const GdkColor *primary,
                              const GdkColor *secondary);

Sets the cursor color to use in a widget, overriding the “cursor-color” and “secondary-cursor-color” style properties. All other style values are left untouched. See also `gtk_widget_modify_style()`.

#### Parameters

widget | a GtkWidget |
primary | the color to use for primary cursor (does not need to be allocated), or `NULL` to undo the effect of previous calls to of `gtk_widget_modify_cursor()`. |
secondary | the color to use for secondary cursor (does not need to be allocated), or `NULL` to undo the effect of previous calls to of `gtk_widget_modify_cursor()`. |

Since: 2.12

### gtk_widget_create_pango_context ()

    PangoContext *
    gtk_widget_create_pango_context (GtkWidget *widget);

Creates a new PangoContext with the appropriate font map, font description, and base direction for drawing text for this widget. See also `gtk_widget_get_pango_context()`.

#### Parameters

widget | a GtkWidget |

#### Returns

the new PangoContext.

[transfer full]

### gtk_widget_get_pango_context ()

    PangoContext *
    gtk_widget_get_pango_context (GtkWidget *widget);

Gets a PangoContext with the appropriate font map, font description, and base direction for this widget. Unlike the context returned by `gtk_widget_create_pango_context()`, this context is owned by the widget (it can be used until the screen for the widget changes or the widget is removed from its toplevel), and will be updated to match any changes to the widget's attributes.

If you create and keep a PangoLayout using this context, you must deal with changes to the context by calling `pango_layout_context_changed()` on the layout in response to the “style-set” and “direction-changed” signals for the widget.

#### Parameters

widget | a GtkWidget |

#### Returns

the PangoContext for the widget.

[transfer none]

### gtk_widget_create_pango_layout ()

    PangoLayout *
    gtk_widget_create_pango_layout (GtkWidget *widget,
                                    const gchar *text);

Creates a new PangoLayout with the appropriate font map, font description, and base direction for drawing text for this widget.

If you keep a PangoLayout created in this way around, in order to notify the layout of changes to the base direction or font of this widget, you must call `pango_layout_context_changed()` in response to the “style-set” and “direction-changed” signals for the widget.

#### Parameters

widget | a GtkWidget |
text | text to set on the layout (can be `NULL`) |

#### Returns

the new PangoLayout.

[transfer full]

### gtk_widget_render_icon ()

    GdkPixbuf *
    gtk_widget_render_icon (GtkWidget *widget,
                            const gchar *stock_id,
                            GtkIconSize size,
                            const gchar *detail);

A convenience function that uses the theme engine and RC file settings for `widget` to look up `stock_id` and render it to a pixbuf. `stock_id` should be a stock icon ID such as GTK_STOCK_OPEN or GTK_STOCK_OK. `size` should be a size such as GTK_ICON_SIZE_MENU. `detail` should be a string that identifies the widget or code doing the rendering, so that theme engines can special-case rendering for that widget or code.

The pixels in the returned GdkPixbuf are shared with the rest of the application and should not be modified. The pixbuf should be freed after use with `g_object_unref()`.

#### Parameters

widget | a GtkWidget |
stock_id | a stock ID |
size | (type int) a stock size. A size of (GtkIconSize)-1 means render at the size of the source and don't scale (if there are multiple source sizes, GTK+ picks one of the available sizes). |
detail | render detail to pass to theme engine. | [allow-none]

#### Returns

a new pixbuf, or `NULL` if the stock ID wasn't known.

[transfer full]

### gtk_widget_pop_composite_child ()

    void
    gtk_widget_pop_composite_child (void);

Cancels the effect of a previous call to `gtk_widget_push_composite_child()`.

### gtk_widget_push_composite_child ()

    void
    gtk_widget_push_composite_child (void);

Makes all newly-created widgets as composite children until the corresponding `gtk_widget_pop_composite_child()` call.

A composite child is a child that's an implementation detail of the container it's inside and should not be visible to people using the container. Composite children aren't treated differently by GTK (but see `gtk_container_foreach()` vs. `gtk_container_forall()`), but e.g. GUI builders might want to treat them in a different way.

Here is a simple example:

    1
    2
    3
    4
    5
    6
    7
    gtk_widget_push_composite_child ();
    scrolled_window->hscrollbar = gtk_hscrollbar_new (hadjustment);
    gtk_widget_set_composite_name (scrolled_window->hscrollbar, "hscrollbar");
    gtk_widget_pop_composite_child ();
    gtk_widget_set_parent (scrolled_window->hscrollbar,
                           GTK_WIDGET (scrolled_window));
    g_object_ref (scrolled_window->hscrollbar);

### gtk_widget_queue_clear ()

    void
    gtk_widget_queue_clear (GtkWidget *widget);

`gtk_widget_queue_clear` has been deprecated since version 2.2 and should not be used in newly-written code.

Use `gtk_widget_queue_draw()` instead.

This function does the same as `gtk_widget_queue_draw()`.

#### Parameters

widget | a GtkWidget |

### gtk_widget_queue_clear_area ()

    void
    gtk_widget_queue_clear_area (GtkWidget *widget,
                                 gint x,
                                 gint y,
                                 gint width,
                                 gint height);

`gtk_widget_queue_clear_area` has been deprecated since version 2.2 and should not be used in newly-written code.

Use `gtk_widget_queue_draw_area()` instead.

This function is no longer different from `gtk_widget_queue_draw_area()`, though it once was. Now it just calls `gtk_widget_queue_draw_area()`. Originally `gtk_widget_queue_clear_area()` would force a redraw of the background for `GTK_NO_WINDOW` widgets, and `gtk_widget_queue_draw_area()` would not. Now both functions ensure the background will be redrawn.

#### Parameters

widget | a GtkWidget |
x | x coordinate of upper-left corner of rectangle to redraw |
y | y coordinate of upper-left corner of rectangle to redraw |
width | width of region to draw |
height | height of region to draw |

### gtk_widget_queue_draw_area ()

    void
    gtk_widget_queue_draw_area (GtkWidget *widget,
                                gint x,
                                gint y,
                                gint width,
                                gint height);

Invalidates the rectangular area of `widget` defined by `x` , `y` , `width` and `height` by calling `gdk_window_invalidate_rect()` on the widget's window and all its child windows. Once the main loop becomes idle (after the current batch of events has been processed, roughly), the window will receive expose events for the union of all regions that have been invalidated.

Normally you would only use this function in widget implementations. You might also use it, or `gdk_window_invalidate_rect()` directly, to schedule a redraw of a GtkDrawingArea or some portion thereof.

Frequently you can just call `gdk_window_invalidate_rect()` or `gdk_window_invalidate_region()` instead of this function. Those functions will invalidate only a single window, instead of the widget and all its children.

The advantage of adding to the invalidated region compared to simply drawing immediately is efficiency; using an invalid region ensures that you only have to redraw one time.

#### Parameters

widget | a GtkWidget |
x | x coordinate of upper-left corner of rectangle to redraw |
y | y coordinate of upper-left corner of rectangle to redraw |
width | width of region to draw |
height | height of region to draw |

### gtk_widget_reset_shapes ()

    void
    gtk_widget_reset_shapes (GtkWidget *widget);

`gtk_widget_reset_shapes` is deprecated and should not be used in newly-written code.

This function is being removed in GTK+ 3.0. Don't use it.

Recursively resets the shape on this widget and its descendants.

#### Parameters

widget | a GtkWidget |

### gtk_widget_set_app_paintable ()

    void
    gtk_widget_set_app_paintable (GtkWidget *widget,
                                  gboolean app_paintable);

Sets whether the application intends to draw on the widget in an “expose-event” handler.

This is a hint to the widget and does not affect the behavior of the GTK+ core; many widgets ignore this flag entirely. For widgets that do pay attention to the flag, such as GtkEventBox and GtkWindow, the effect is to suppress default themed drawing of the widget's background. (Children of the widget will still be drawn.) The application is then entirely responsible for drawing the widget background.

Note that the background is still drawn when the widget is mapped. If this is not suitable (e.g. because you want to make a transparent window using an RGBA visual), you can work around this by doing:

    1
    2
    3
    gtk_widget_realize (window);
    gdk_window_set_back_pixmap (window->window, NULL, FALSE);
    gtk_widget_show (window);

#### Parameters

widget | a GtkWidget |
app_paintable | `TRUE` if the application will paint on the widget |

### gtk_widget_set_double_buffered ()

    void
    gtk_widget_set_double_buffered (GtkWidget *widget,
                                    gboolean double_buffered);

Widgets are double buffered by default; you can use this function to turn off the buffering. "Double buffered" simply means that `gdk_window_begin_paint_region()` and `gdk_window_end_paint()` are called automatically around expose events sent to the widget. `gdk_window_begin_paint()` diverts all drawing to a widget's window to an offscreen buffer, and `gdk_window_end_paint()` draws the buffer to the screen. The result is that users see the window update in one smooth step, and don't see individual graphics primitives being rendered.

In very simple terms, double buffered widgets don't flicker, so you would only use this function to turn off double buffering if you had special needs and really knew what you were doing.

Note: if you turn off double-buffering, you have to handle expose events, since even the clearing to the background color or pixmap will not happen automatically (as it is done in `gdk_window_begin_paint()`).

#### Parameters

widget | a GtkWidget |
double_buffered | `TRUE` to double-buffer a widget |

### gtk_widget_set_redraw_on_allocate ()

    void
    gtk_widget_set_redraw_on_allocate (GtkWidget *widget,
                                       gboolean redraw_on_allocate);

Sets whether the entire widget is queued for drawing when its size allocation changes. By default, this setting is `TRUE` and the entire widget is redrawn on every size change. If your widget leaves the upper left unchanged when made bigger, turning this setting off will improve performance.

Note that for `NO_WINDOW` widgets setting this flag to `FALSE` turns off all allocation on resizing: the widget will not even redraw if its position changes; this is to allow containers that don't draw anything to avoid excess invalidations. If you set this flag on a `NO_WINDOW` widget that does draw on `widget->window` , you are responsible for invalidating both the old and new allocation of the widget when the widget is moved and responsible for invalidating regions newly when the widget increases size.

#### Parameters

widget | a GtkWidget |
redraw_on_allocate | if `TRUE`, the entire widget will be redrawn when it is allocated to a new size. Otherwise, only the new portion of the widget will be redrawn. |

### gtk_widget_set_composite_name ()

    void
    gtk_widget_set_composite_name (GtkWidget *widget,
                                   const gchar *name);

Sets a widgets composite name. The widget must be a composite child of its parent; see `gtk_widget_push_composite_child()`.

#### Parameters

widget | a GtkWidget. |
name | the name to set |

### gtk_widget_set_scroll_adjustments ()

    gboolean
    gtk_widget_set_scroll_adjustments (GtkWidget *widget,
                                       GtkAdjustment *hadjustment,
                                       GtkAdjustment *vadjustment);

For widgets that support scrolling, sets the scroll adjustments and returns `TRUE`. For widgets that don't support scrolling, does nothing and returns `FALSE`. Widgets that don't support scrolling can be scrolled by placing them in a GtkViewport, which does support scrolling.

#### Parameters

widget | a GtkWidget |
hadjustment | an adjustment for horizontal scrolling, or `NULL`. | [allow-none]
vadjustment | an adjustment for vertical scrolling, or `NULL`. | [allow-none]

#### Returns

`TRUE` if the widget supports scrolling

### gtk_widget_mnemonic_activate ()

    gboolean
    gtk_widget_mnemonic_activate (GtkWidget *widget,
                                  gboolean group_cycling);

Emits the “mnemonic-activate” signal.

The default handler for this signal activates the `widget` if `group_cycling` is `FALSE`, and just grabs the focus if `group_cycling` is `TRUE`.

#### Parameters

widget | a GtkWidget |
group_cycling | `TRUE` if there are other widgets with the same mnemonic |

#### Returns

`TRUE` if the signal has been handled

### gtk_widget_class_install_style_property ()

    void
    gtk_widget_class_install_style_property
                                   (GtkWidgetClass *klass,
                                    GParamSpec *pspec);

Installs a style property on a widget class. The parser for the style property is determined by the value type of `pspec` .

#### Parameters

klass | a GtkWidgetClass |
pspec | the GParamSpec for the property |

### gtk_widget_class_install_style_property_parser ()

    void
    gtk_widget_class_install_style_property_parser
                                   (GtkWidgetClass *klass,
                                    GParamSpec *pspec,
                                    GtkRcPropertyParser parser);

Installs a style property on a widget class.

#### Parameters

klass | a GtkWidgetClass |
pspec | the GParamSpec for the style property |
parser | the parser for the style property |

### gtk_widget_class_find_style_property ()

    GParamSpec *
    gtk_widget_class_find_style_property (GtkWidgetClass *klass,
                                          const gchar *property_name);

Finds a style property of a widget class by name.

#### Parameters

klass | a GtkWidgetClass |
property_name | the name of the style property to find |
returns | the GParamSpec of the style property or `NULL` if `class` has no style property with that name. | [transfer none]

Since: 2.2

### gtk_widget_class_list_style_properties ()

    GParamSpec **
    gtk_widget_class_list_style_properties
                                   (GtkWidgetClass *klass,
                                    guint *n_properties);

Returns all style properties of a widget class.

#### Parameters

klass | a GtkWidgetClass |
n_properties | location to return the number of style properties found |
returns | an newly allocated array of GParamSpec*. The array must be freed with `g_free()`. | [array length=n_properties][transfer container]

Since: 2.2

### gtk_widget_region_intersect ()

    GdkRegion *
    gtk_widget_region_intersect (GtkWidget *widget,
                                 const GdkRegion *region);

Computes the intersection of a `widget` 's area and `region` , returning the intersection. The result may be empty, use `gdk_region_empty()` to check.

#### Parameters

widget | a GtkWidget |
region | a GdkRegion, in the same coordinate system as `widget->allocation` . That is, relative to `widget->window` for `NO_WINDOW` widgets; relative to the parent window of `widget->window` for widgets with their own window. |
returns | A newly allocated region holding the intersection of `widget` and `region` . The coordinates of the return value are relative to `widget->window` for `NO_WINDOW` widgets, and relative to the parent window of `widget->window` for widgets with their own window. |

### gtk_widget_send_expose ()

    gint
    gtk_widget_send_expose (GtkWidget *widget,
                            GdkEvent *event);

Very rarely-used function. This function is used to emit an expose event signals on a widget. This function is not normally used directly. The only time it is used is when propagating an expose event to a child `NO_WINDOW` widget, and that is normally done using `gtk_container_propagate_expose()`.

If you want to force an area of a window to be redrawn, use `gdk_window_invalidate_rect()` or `gdk_window_invalidate_region()`. To cause the redraw to be done immediately, follow that call with a call to `gdk_window_process_updates()`.

#### Parameters

widget | a GtkWidget |
event | a expose GdkEvent |

#### Returns

return from the event signal emission (`TRUE` if the event was handled)

### gtk_widget_send_focus_change ()

    gboolean
    gtk_widget_send_focus_change (GtkWidget *widget,
                                  GdkEvent *event);

Sends the focus change `event` to `widget`

This function is not meant to be used by applications. The only time it should be used is when it is necessary for a GtkWidget to assign focus to a widget that is semantically owned by the first widget even though it's not a direct child - for instance, a search entry in a floating window similar to the quick search in GtkTreeView.

An example of its usage is:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    GdkEvent *fevent = gdk_event_new (GDK_FOCUS_CHANGE);

    fevent->focus_change.type = GDK_FOCUS_CHANGE;
    fevent->focus_change.in = TRUE;
    fevent->focus_change.window = gtk_widget_get_window (widget);
    if (fevent->focus_change.window != NULL)
      g_object_ref (fevent->focus_change.window);

    gtk_widget_send_focus_change (widget, fevent);

    gdk_event_free (event);

#### Parameters

widget | a GtkWidget |
event | a GdkEvent of type GDK_FOCUS_CHANGE |

#### Returns

the return value from the event signal emission: `TRUE` if the event was handled, and `FALSE` otherwise

Since: 2.22

### gtk_widget_style_get ()

    void
    gtk_widget_style_get (GtkWidget *widget,
                          const gchar *first_property_name,
                          ...);

Gets the values of a multiple style properties of `widget` .

#### Parameters

widget | a GtkWidget |
first_property_name | the name of the first property to get |
Varargs | pairs of property names and locations to return the property values, starting with the location for `first_property_name` , terminated by `NULL`. |

### gtk_widget_style_get_property ()

    void
    gtk_widget_style_get_property (GtkWidget *widget,
                                   const gchar *property_name,
                                   GValue *value);

Gets the value of a style property of `widget` .

#### Parameters

widget | a GtkWidget |
property_name | the name of a style property |
value | location to return the property value |

### gtk_widget_style_get_valist ()

    void
    gtk_widget_style_get_valist (GtkWidget *widget,
                                 const gchar *first_property_name,
                                 va_list var_args);

Non-vararg variant of `gtk_widget_style_get()`. Used primarily by language bindings.

#### Parameters

widget | a GtkWidget |
first_property_name | the name of the first property to get |
var_args | a va_list of pairs of property names and locations to return the property values, starting with the location for `first_property_name` . |

### gtk_widget_style_attach ()

    void
    gtk_widget_style_attach (GtkWidget *style);

This function attaches the widget's GtkStyle to the widget's GdkWindow. It is a replacement for

    widget->style = gtk_style_attach (widget->style, widget->window);

and should only ever be called in a derived widget's "realize" implementation which does not chain up to its parent class' "realize" implementation, because one of the parent classes (finally GtkWidget) would attach the style itself.

#### Parameters

widget | a GtkWidget |

Since: 2.20

### gtk_widget_get_accessible ()

    AtkObject *
    gtk_widget_get_accessible (GtkWidget *widget);

`gtk_widget_get_accessible` is deprecated and should not be used in newly-written code.

Returns the accessible object that describes the widget to an assistive technology.

If no accessibility library is loaded (i.e. no ATK implementation library is loaded via `GTK_MODULES` or via another application library, such as libgnome), then this AtkObject instance may be a no-op. Likewise, if no class-specific AtkObject implementation is available for the widget instance in question, it will inherit an AtkObject implementation from the first ancestor class for which such an implementation is defined.

The documentation of the ATK library contains more information about accessible objects and their uses.

#### Parameters

widget | a GtkWidget |

#### Returns

the AtkObject associated with `widget` .

[transfer none]

### gtk_widget_child_focus ()

    gboolean
    gtk_widget_child_focus (GtkWidget *widget,
                            GtkDirectionType direction);

This function is used by custom widget implementations; if you're writing an app, you'd use `gtk_widget_grab_focus()` to move the focus to a particular widget, and `gtk_container_set_focus_chain()` to change the focus tab order. So you may want to investigate those functions instead.

gtk_widget_child_focus() is called by containers as the user moves around the window using keyboard shortcuts. `direction` indicates what kind of motion is taking place (up, down, left, right, tab forward, tab backward). `gtk_widget_child_focus()` emits the “focus” signal; widgets override the default handler for this signal in order to implement appropriate focus behavior.

The default ::focus handler for a widget should return `TRUE` if moving in `direction` left the focus on a focusable location inside that widget, and `FALSE` if moving in `direction` moved the focus outside the widget. If returning `TRUE`, widgets normally call `gtk_widget_grab_focus()` to place the focus accordingly; if returning `FALSE`, they don't modify the current focus location.

This function replaces `gtk_container_focus()` from GTK+ 1.2. It was necessary to check that the child was visible, sensitive, and focusable before calling `gtk_container_focus()`. `gtk_widget_child_focus()` returns `FALSE` if the widget is not currently in a focusable state, so there's no need for those checks.

#### Parameters

widget | a GtkWidget |
direction | direction of focus movement |

#### Returns

`TRUE` if focus ended up inside `widget`

### gtk_widget_child_notify ()

    void
    gtk_widget_child_notify (GtkWidget *widget,
                             const gchar *child_property);

Emits a “child-notify” signal for the

child property`child_property`

on `widget` .

This is the analogue of `g_object_notify()` for child properties.

#### Parameters

widget | a GtkWidget |
child_property | the name of a child property installed on the class of `widget` 's parent |

### gtk_widget_freeze_child_notify ()

    void
    gtk_widget_freeze_child_notify (GtkWidget *widget);

Stops emission of “child-notify” signals on `widget` . The signals are queued until `gtk_widget_thaw_child_notify()` is called on `widget` .

This is the analogue of `g_object_freeze_notify()` for child properties.

#### Parameters

widget | a GtkWidget |

### gtk_widget_get_child_visible ()

    gboolean
    gtk_widget_get_child_visible (GtkWidget *widget);

Gets the value set with `gtk_widget_set_child_visible()`. If you feel a need to use this function, your code probably needs reorganization.

This function is only useful for container implementations and never should be called by an application.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget is mapped with the parent.

### gtk_widget_get_parent ()

    GtkWidget *
    gtk_widget_get_parent (GtkWidget *widget);

Returns the parent container of `widget` .

#### Parameters

widget | a GtkWidget |

#### Returns

the parent container of `widget` , or `NULL`.

[transfer none]

### gtk_widget_get_settings ()

    GtkSettings *
    gtk_widget_get_settings (GtkWidget *widget);

Gets the settings object holding the settings (global property settings, RC file information, etc) used for this widget.

Note that this function can only be called when the GtkWidget is attached to a toplevel, since the settings object is specific to a particular GdkScreen.

#### Parameters

widget | a GtkWidget |

#### Returns

the relevant GtkSettings object.

[transfer none]

### gtk_widget_get_clipboard ()

    GtkClipboard *
    gtk_widget_get_clipboard (GtkWidget *widget,
                              GdkAtom selection);

Returns the clipboard object for the given selection to be used with `widget` . `widget` must have a GdkDisplay associated with it, so must be attached to a toplevel window.

#### Parameters

widget | a GtkWidget |
selection | a GdkAtom which identifies the clipboard to use. `GDK_SELECTION_CLIPBOARD` gives the default clipboard. Another common value is `GDK_SELECTION_PRIMARY`, which gives the primary X selection. |

#### Returns

the appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent for all time.

[transfer none]

Since: 2.2

### gtk_widget_get_display ()

    GdkDisplay *
    gtk_widget_get_display (GtkWidget *widget);

Get the GdkDisplay for the toplevel window associated with this widget. This function can only be called after the widget has been added to a widget hierarchy with a GtkWindow at the top.

In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

#### Parameters

widget | a GtkWidget |

#### Returns

the GdkDisplay for the toplevel for this widget.

[transfer none]

Since: 2.2

### gtk_widget_get_root_window ()

    GdkWindow *
    gtk_widget_get_root_window (GtkWidget *widget);

Get the root window where this widget is located. This function can only be called after the widget has been added to a widget hierarchy with GtkWindow at the top.

The root window is useful for such purposes as creating a popup GdkWindow associated with the window. In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

#### Parameters

widget | a GtkWidget |

#### Returns

the GdkWindow root window for the toplevel for this widget.

[transfer none]

Since: 2.2

### gtk_widget_get_screen ()

    GdkScreen *
    gtk_widget_get_screen (GtkWidget *widget);

Get the GdkScreen from the toplevel window associated with this widget. This function can only be called after the widget has been added to a widget hierarchy with a GtkWindow at the top.

In general, you should only create screen specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

#### Parameters

widget | a GtkWidget |

#### Returns

the GdkScreen for the toplevel for this widget.

[transfer none]

Since: 2.2

### gtk_widget_has_screen ()

    gboolean
    gtk_widget_has_screen (GtkWidget *widget);

Checks whether there is a GdkScreen is associated with this widget. All toplevel widgets have an associated screen, and all widgets added into a hierarchy with a toplevel window at the top.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if there is a GdkScreen associcated with the widget.

Since: 2.2

### gtk_widget_get_size_request ()

    void
    gtk_widget_get_size_request (GtkWidget *widget,
                                 gint *width,
                                 gint *height);

Gets the size request that was explicitly set for the widget using `gtk_widget_set_size_request()`. A value of -1 stored in `width` or `height` indicates that that dimension has not been set explicitly and the natural requisition of the widget will be used intead. See `gtk_widget_set_size_request()`. To get the size a widget will actually use, call `gtk_widget_size_request()` instead of this function.

#### Parameters

widget | a GtkWidget |
width | return location for width, or `NULL`. | [out][allow-none]
height | return location for height, or `NULL`. | [out][allow-none]

### gtk_widget_pop_visual

    #define gtk_widget_pop_visual()               ((void) 0)

`gtk_widget_pop_visual` is deprecated and should not be used in newly-written code.

This function is deprecated; it does nothing.

### gtk_widget_push_visual()

    #define gtk_widget_push_visual(visual)        ((void) 0)

`gtk_widget_push_visual` is deprecated and should not be used in newly-written code.

This function is deprecated; it does nothing.

#### Parameters

visual | a visual |

### gtk_widget_set_child_visible ()

    void
    gtk_widget_set_child_visible (GtkWidget *widget,
                                  gboolean is_visible);

Sets whether `widget` should be mapped along with its when its parent is mapped and `widget` has been shown with `gtk_widget_show()`.

The child visibility can be set for widget before it is added to a container with `gtk_widget_set_parent()`, to avoid mapping children unnecessary before immediately unmapping them. However it will be reset to its default state of `TRUE` when the widget is removed from a container.

Note that changing the child visibility of a widget does not queue a resize on the widget. Most of the time, the size of a widget is computed from all visible children, whether or not they are mapped. If this is not the case, the container can queue a resize itself.

This function is only useful for container implementations and never should be called by an application.

#### Parameters

widget | a GtkWidget |
is_visible | if `TRUE`, `widget` should be mapped along with its parent. |

### gtk_widget_set_default_visual()

    #define gtk_widget_set_default_visual(visual) ((void) 0)

`gtk_widget_set_default_visual` is deprecated and should not be used in newly-written code.

This function is deprecated; it does nothing.

#### Parameters

visual | a visual |

### gtk_widget_set_size_request ()

    void
    gtk_widget_set_size_request (GtkWidget *widget,
                                 gint width,
                                 gint height);

Sets the minimum size of a widget; that is, the widget's size request will be `width` by `height` . You can use this function to force a widget to be either larger or smaller than it normally would be.

In most cases, `gtk_window_set_default_size()` is a better choice for toplevel windows than this function; setting the default size will still allow users to shrink the window. Setting the size request will force them to leave the window at least as large as the size request. When dealing with window sizes, `gtk_window_set_geometry_hints()` can be a useful function as well.

Note the inherent danger of setting any fixed size - themes, translations into other languages, different fonts, and user action can all change the appropriate size for a given widget. So, it's basically impossible to hardcode a size that will always be correct.

The size request of a widget is the smallest size a widget can accept while still functioning well and drawing itself correctly. However in some strange cases a widget may be allocated less than its requested size, and in many cases a widget may be allocated more space than it requested.

If the size request in a given direction is -1 (unset), then the "natural" size request of the widget will be used instead.

Widgets can't actually be allocated a size less than 1 by 1, but you can pass 0,0 to this function to mean "as small as possible."

#### Parameters

widget | a GtkWidget |
width | width `widget` should request, or -1 to unset |
height | height `widget` should request, or -1 to unset |

### gtk_widget_set_visual()

    #define gtk_widget_set_visual(widget,visual)  ((void) 0)

`gtk_widget_set_visual` is deprecated and should not be used in newly-written code.

This function is deprecated; it does nothing.

#### Parameters

widget | a GtkWidget |
visual | a visual |

### gtk_widget_thaw_child_notify ()

    void
    gtk_widget_thaw_child_notify (GtkWidget *widget);

Reverts the effect of a previous call to `gtk_widget_freeze_child_notify()`. This causes all queued “child-notify” signals on `widget` to be emitted.

#### Parameters

widget | a GtkWidget |

### gtk_widget_set_no_show_all ()

    void
    gtk_widget_set_no_show_all (GtkWidget *widget,
                                gboolean no_show_all);

Sets the “no-show-all” property, which determines whether calls to `gtk_widget_show_all()` and `gtk_widget_hide_all()` will affect this widget.

This is mostly for use in constructing widget hierarchies with externally controlled visibility, see GtkUIManager.

#### Parameters

widget | a GtkWidget |
no_show_all | the new value for the "no-show-all" property |

Since: 2.4

### gtk_widget_get_no_show_all ()

    gboolean
    gtk_widget_get_no_show_all (GtkWidget *widget);

Returns the current value of the GtkWidget:no-show-all property, which determines whether calls to `gtk_widget_show_all()` and `gtk_widget_hide_all()` will affect this widget.

#### Parameters

widget | a GtkWidget |

#### Returns

the current value of the "no-show-all" property.

Since: 2.4

### gtk_widget_list_mnemonic_labels ()

    GList *
    gtk_widget_list_mnemonic_labels (GtkWidget *widget);

Returns a newly allocated list of the widgets, normally labels, for which this widget is a the target of a mnemonic (see for example, `gtk_label_set_mnemonic_widget()`).

The widgets in the list are not individually referenced. If you want to iterate through the list and perform actions involving callbacks that might destroy the widgets, you must call `g_list_foreach (result, (GFunc)g_object_ref, NULL)` first, and then unref all the widgets afterwards.

#### Parameters

widget | a GtkWidget |

#### Returns

the list of mnemonic labels; free this list with `g_list_free()` when you are done with it.

[element-type GtkWidget][transfer container]

Since: 2.4

### gtk_widget_add_mnemonic_label ()

    void
    gtk_widget_add_mnemonic_label (GtkWidget *widget,
                                   GtkWidget *label);

Adds a widget to the list of mnemonic labels for this widget. (See `gtk_widget_list_mnemonic_labels()`). Note the list of mnemonic labels for the widget is cleared when the widget is destroyed, so the caller must make sure to update its internal state at this point as well, by using a connection to the “destroy” signal or a weak notifier.

#### Parameters

widget | a GtkWidget |
label | a GtkWidget that acts as a mnemonic label for `widget` |

Since: 2.4

### gtk_widget_remove_mnemonic_label ()

    void
    gtk_widget_remove_mnemonic_label (GtkWidget *widget,
                                      GtkWidget *label);

Removes a widget from the list of mnemonic labels for this widget. (See `gtk_widget_list_mnemonic_labels()`). The widget must have previously been added to the list with `gtk_widget_add_mnemonic_label()`.

#### Parameters

widget | a GtkWidget |
label | a GtkWidget that was previously set as a mnemnic label for `widget` with `gtk_widget_add_mnemonic_label()`. |

Since: 2.4

### gtk_widget_get_action ()

    GtkAction *
    gtk_widget_get_action (GtkWidget *widget);

`gtk_widget_get_action` has been deprecated since version 2.16 and should not be used in newly-written code.

Use `gtk_activatable_get_related_action()` instead.

Returns the GtkAction that `widget` is a proxy for. See also `gtk_action_get_proxies()`.

#### Parameters

widget | a GtkWidget |

#### Returns

the action that a widget is a proxy for, or `NULL`, if it is not attached to an action.

Since: 2.10

### gtk_widget_is_composited ()

    gboolean
    gtk_widget_is_composited (GtkWidget *widget);

Whether `widget` can rely on having its alpha channel drawn correctly. On X11 this function returns whether a compositing manager is running for `widget` 's screen.

Please note that the semantics of this call will change in the future if used on a widget that has a composited window in its hierarchy (as set by `gdk_window_set_composited()`).

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget can rely on its alpha channel being drawn correctly.

Since: 2.10

### gtk_widget_error_bell ()

    void
    gtk_widget_error_bell (GtkWidget *widget);

Notifies the user about an input-related error on this widget. If the “gtk-error-bell” setting is `TRUE`, it calls `gdk_window_beep()`, otherwise it does nothing.

Note that the effect of `gdk_window_beep()` can be configured in many ways, depending on the windowing backend and the desktop environment or window manager that is used.

#### Parameters

widget | a GtkWidget |

Since: 2.12

### gtk_widget_keynav_failed ()

    gboolean
    gtk_widget_keynav_failed (GtkWidget *widget,
                              GtkDirectionType direction);

This function should be called whenever keyboard navigation within a single widget hits a boundary. The function emits the “keynav-failed” signal on the widget and its return value should be interpreted in a way similar to the return value of `gtk_widget_child_focus()`:

When `TRUE` is returned, stay in the widget, the failed keyboard navigation is Ok and/or there is nowhere we can/should move the focus to.

When `FALSE` is returned, the caller should continue with keyboard navigation outside the widget, e.g. by calling `gtk_widget_child_focus()` on the widget's toplevel.

The default ::keynav-failed handler returns `TRUE` for `GTK_DIR_TAB_FORWARD` and `GTK_DIR_TAB_BACKWARD`. For the other values of GtkDirectionType, it looks at the “gtk-keynav-cursor-only” setting and returns `FALSE` if the setting is `TRUE`. This way the entire user interface becomes cursor-navigatable on input devices such as mobile phones which only have cursor keys but no tab key.

Whenever the default handler returns `TRUE`, it also calls `gtk_widget_error_bell()` to notify the user of the failed keyboard navigation.

A use case for providing an own implementation of ::keynav-failed (either by connecting to it or by overriding it) would be a row of GtkEntry widgets where the user should be able to navigate the entire row with the cursor keys, as e.g. known from user interfaces that require entering license keys.

#### Parameters

widget | a GtkWidget |
direction | direction of focus movement |

#### Returns

`TRUE` if stopping keyboard navigation is fine, `FALSE` if the emitting widget should try to handle the keyboard navigation attempt in its parent container(s).

Since: 2.12

### gtk_widget_get_tooltip_markup ()

    gchar *
    gtk_widget_get_tooltip_markup (GtkWidget *widget);

Gets the contents of the tooltip for `widget` .

#### Parameters

widget | a GtkWidget |

#### Returns

the tooltip text, or `NULL`. You should free the returned string with `g_free()` when done.

Since: 2.12

### gtk_widget_set_tooltip_markup ()

    void
    gtk_widget_set_tooltip_markup (GtkWidget *widget,
                                   const gchar *markup);

Sets `markup` as the contents of the tooltip, which is marked up with the Pango text markup language.

This function will take care of setting GtkWidget:has-tooltip to `TRUE` and of the default handler for the GtkWidget::query-tooltip signal.

See also the GtkWidget:tooltip-markup property and `gtk_tooltip_set_markup()`.

#### Parameters

widget | a GtkWidget |
markup | the contents of the tooltip for `widget` , or `NULL`. | [allow-none]

Since: 2.12

### gtk_widget_get_tooltip_text ()

    gchar *
    gtk_widget_get_tooltip_text (GtkWidget *widget);

Gets the contents of the tooltip for `widget` .

#### Parameters

widget | a GtkWidget |

#### Returns

the tooltip text, or `NULL`. You should free the returned string with `g_free()` when done.

Since: 2.12

### gtk_widget_set_tooltip_text ()

    void
    gtk_widget_set_tooltip_text (GtkWidget *widget,
                                 const gchar *text);

Sets `text` as the contents of the tooltip. This function will take care of setting GtkWidget:has-tooltip to `TRUE` and of the default handler for the GtkWidget::query-tooltip signal.

See also the GtkWidget:tooltip-text property and `gtk_tooltip_set_text()`.

#### Parameters

widget | a GtkWidget |
text | the contents of the tooltip for `widget` |

Since: 2.12

### gtk_widget_get_tooltip_window ()

    GtkWindow *
    gtk_widget_get_tooltip_window (GtkWidget *widget);

Returns the GtkWindow of the current tooltip. This can be the GtkWindow created by default, or the custom tooltip window set using `gtk_widget_set_tooltip_window()`.

#### Parameters

widget | a GtkWidget |

#### Returns

The GtkWindow of the current tooltip.

[transfer none]

Since: 2.12

### gtk_widget_set_tooltip_window ()

    void
    gtk_widget_set_tooltip_window (GtkWidget *widget,
                                   GtkWindow *custom_window);

Replaces the default, usually yellow, window used for displaying tooltips with `custom_window` . GTK+ will take care of showing and hiding `custom_window` at the right moment, to behave likewise as the default tooltip window. If `custom_window` is `NULL`, the default tooltip window will be used.

If the custom window should have the default theming it needs to have the name "gtk-tooltip", see `gtk_widget_set_name()`.

#### Parameters

widget | a GtkWidget |
custom_window | a GtkWindow, or `NULL`. | [allow-none]

Since: 2.12

### gtk_widget_get_has_tooltip ()

    gboolean
    gtk_widget_get_has_tooltip (GtkWidget *widget);

Returns the current value of the has-tooltip property. See GtkWidget:has-tooltip for more information.

#### Parameters

widget | a GtkWidget |

#### Returns

current value of has-tooltip on `widget` .

Since: 2.12

### gtk_widget_set_has_tooltip ()

    void
    gtk_widget_set_has_tooltip (GtkWidget *widget,
                                gboolean has_tooltip);

Sets the has-tooltip property on `widget` to `has_tooltip` . See GtkWidget:has-tooltip for more information.

#### Parameters

widget | a GtkWidget |
has_tooltip | whether or not `widget` has a tooltip. |

Since: 2.12

### gtk_widget_trigger_tooltip_query ()

    void
    gtk_widget_trigger_tooltip_query (GtkWidget *widget);

Triggers a tooltip query on the display where the toplevel of `widget` is located. See `gtk_tooltip_trigger_tooltip_query()` for more information.

#### Parameters

widget | a GtkWidget |

Since: 2.12

### gtk_widget_get_snapshot ()

    GdkPixmap *
    gtk_widget_get_snapshot (GtkWidget *widget,
                             GdkRectangle *clip_rect);

Create a GdkPixmap of the contents of the widget and its children.

Works even if the widget is obscured. The depth and visual of the resulting pixmap is dependent on the widget being snapshot and likely differs from those of a target widget displaying the pixmap. The function `gdk_pixbuf_get_from_drawable()` can be used to convert the pixmap to a visual independant representation.

The snapshot area used by this function is the `widget` 's allocation plus any extra space occupied by additional windows belonging to this widget (such as the arrows of a spin button). Thus, the resulting snapshot pixmap is possibly larger than the allocation.

If `clip_rect` is non-`NULL`, the resulting pixmap is shrunken to match the specified clip_rect. The (x,y) coordinates of `clip_rect` are interpreted widget relative. If width or height of `clip_rect` are 0 or negative, the width or height of the resulting pixmap will be shrunken by the respective amount. For instance a `clip_rect` `{ +5, +5, -10, -10 }` will chop off 5 pixels at each side of the snapshot pixmap. If non-`NULL`, `clip_rect` will contain the exact widget-relative snapshot coordinates upon return. A `clip_rect` of `{ -1, -1, 0, 0 }` can be used to preserve the auto-grown snapshot area and use `clip_rect` as a pure output parameter.

The returned pixmap can be `NULL`, if the resulting `clip_area` was empty.

#### Parameters

widget | a GtkWidget |
clip_rect | a GdkRectangle or `NULL`. | [allow-none]

#### Returns

GdkPixmap snapshot of the widget

Since: 2.14

### gtk_widget_get_window ()

    GdkWindow *
    gtk_widget_get_window (GtkWidget *widget);

Returns the widget's window if it is realized, `NULL` otherwise

#### Parameters

widget | a GtkWidget |

#### Returns

`widget` 's window.

[transfer none]

Since: 2.14

### gtk_widget_get_allocation ()

    void
    gtk_widget_get_allocation (GtkWidget *widget,
                               GtkAllocation *allocation);

Retrieves the widget's allocation.

#### Parameters

widget | a GtkWidget |
allocation | a pointer to a GtkAllocation to copy to. | [out]

Since: 2.18

### gtk_widget_set_allocation ()

    void
    gtk_widget_set_allocation (GtkWidget *widget,
                               const GtkAllocation *allocation);

Sets the widget's allocation. This should not be used directly, but from within a widget's size_allocate method.

#### Parameters

widget | a GtkWidget |
allocation | a pointer to a GtkAllocation to copy from |

Since: 2.18

### gtk_widget_get_app_paintable ()

    gboolean
    gtk_widget_get_app_paintable (GtkWidget *widget);

Determines whether the application intends to draw on the widget in an “expose-event” handler.

See `gtk_widget_set_app_paintable()`

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget is app paintable

Since: 2.18

### gtk_widget_get_can_default ()

    gboolean
    gtk_widget_get_can_default (GtkWidget *widget);

Determines whether `widget` can be a default widget. See `gtk_widget_set_can_default()`.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if `widget` can be a default widget, `FALSE` otherwise

Since: 2.18

### gtk_widget_set_can_default ()

    void
    gtk_widget_set_can_default (GtkWidget *widget,
                                gboolean can_default);

Specifies whether `widget` can be a default widget. See `gtk_widget_grab_default()` for details about the meaning of "default".

#### Parameters

widget | a GtkWidget |
can_default | whether or not `widget` can be a default widget. |

Since: 2.18

### gtk_widget_get_can_focus ()

    gboolean
    gtk_widget_get_can_focus (GtkWidget *widget);

Determines whether `widget` can own the input focus. See `gtk_widget_set_can_focus()`.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if `widget` can own the input focus, `FALSE` otherwise

Since: 2.18

### gtk_widget_set_can_focus ()

    void
    gtk_widget_set_can_focus (GtkWidget *widget,
                              gboolean can_focus);

Specifies whether `widget` can own the input focus. See `gtk_widget_grab_focus()` for actually setting the input focus on a widget.

#### Parameters

widget | a GtkWidget |
can_focus | whether or not `widget` can own the input focus. |

Since: 2.18

### gtk_widget_get_double_buffered ()

    gboolean
    gtk_widget_get_double_buffered (GtkWidget *widget);

Determines whether the widget is double buffered.

See `gtk_widget_set_double_buffered()`

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget is double buffered

Since: 2.18

### gtk_widget_get_has_window ()

    gboolean
    gtk_widget_get_has_window (GtkWidget *widget);

Determines whether `widget` has a GdkWindow of its own. See `gtk_widget_set_has_window()`.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if `widget` has a window, `FALSE` otherwise

Since: 2.18

### gtk_widget_set_has_window ()

    void
    gtk_widget_set_has_window (GtkWidget *widget,
                               gboolean has_window);

Specifies whether `widget` has a GdkWindow of its own. Note that all realized widgets have a non-`NULL` "window" pointer (`gtk_widget_get_window()` never returns a `NULL` window when a widget is realized), but for many of them it's actually the GdkWindow of one of its parent widgets. Widgets that do not create a `window` for themselves in GtkWidget::`realize()` must announce this by calling this function with `has_window` = `FALSE`.

This function should only be called by widget implementations, and they should call it in their `init()` function.

#### Parameters

widget | a GtkWidget |
has_window | whether or not `widget` has a window. |

Since: 2.18

### gtk_widget_get_sensitive ()

    gboolean
    gtk_widget_get_sensitive (GtkWidget *widget);

Returns the widget's sensitivity (in the sense of returning the value that has been set using `gtk_widget_set_sensitive()`).

The effective sensitivity of a widget is however determined by both its own and its parent widget's sensitivity. See `gtk_widget_is_sensitive()`.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget is sensitive

Since: 2.18

### gtk_widget_is_sensitive ()

    gboolean
    gtk_widget_is_sensitive (GtkWidget *widget);

Returns the widget's effective sensitivity, which means it is sensitive itself and also its parent widget is sensntive

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget is effectively sensitive

Since: 2.18

### gtk_widget_get_state ()

    GtkStateType
    gtk_widget_get_state (GtkWidget *widget);

Returns the widget's state. See `gtk_widget_set_state()`.

#### Parameters

widget | a GtkWidget |

#### Returns

the state of `widget` .

Since: 2.18

### gtk_widget_get_visible ()

    gboolean
    gtk_widget_get_visible (GtkWidget *widget);

Determines whether the widget is visible. Note that this doesn't take into account whether the widget's parent is also visible or the widget is obscured in any way.

See `gtk_widget_set_visible()`.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget is visible

Since: 2.18

### gtk_widget_set_visible ()

    void
    gtk_widget_set_visible (GtkWidget *widget,
                            gboolean visible);

Sets the visibility state of `widget` . Note that setting this to `TRUE` doesn't mean the widget is actually viewable, see `gtk_widget_get_visible()`.

This function simply calls `gtk_widget_show()` or `gtk_widget_hide()` but is nicer to use when the visibility of the widget depends on some condition.

#### Parameters

widget | a GtkWidget |
visible | whether the widget should be shown or not |

Since: 2.18

### gtk_widget_has_default ()

    gboolean
    gtk_widget_has_default (GtkWidget *widget);

Determines whether `widget` is the current default widget within its toplevel. See `gtk_widget_set_can_default()`.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if `widget` is the current default widget within its toplevel, `FALSE` otherwise

Since: 2.18

### gtk_widget_has_focus ()

    gboolean
    gtk_widget_has_focus (GtkWidget *widget);

Determines if the widget has the global input focus. See `gtk_widget_is_focus()` for the difference between having the global input focus, and only having the focus within a toplevel.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget has the global input focus.

Since: 2.18

### gtk_widget_has_grab ()

    gboolean
    gtk_widget_has_grab (GtkWidget *widget);

Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse).

See also `gtk_grab_add()`.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget is in the grab_widgets stack

Since: 2.18

### gtk_widget_has_rc_style ()

    gboolean
    gtk_widget_has_rc_style (GtkWidget *widget);

Determines if the widget style has been looked up through the rc mechanism.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget has been looked up through the rc mechanism, `FALSE` otherwise.

Since: 2.20

### gtk_widget_is_drawable ()

    gboolean
    gtk_widget_is_drawable (GtkWidget *widget);

Determines whether `widget` can be drawn to. A widget can be drawn to if it is mapped and visible.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if `widget` is drawable, `FALSE` otherwise

Since: 2.18

### gtk_widget_is_toplevel ()

    gboolean
    gtk_widget_is_toplevel (GtkWidget *widget);

Determines whether `widget` is a toplevel widget. Currently only GtkWindow and GtkInvisible are toplevel widgets. Toplevel widgets have no parent widget.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if `widget` is a toplevel, `FALSE` otherwise

Since: 2.18

### gtk_widget_set_window ()

    void
    gtk_widget_set_window (GtkWidget *widget,
                           GdkWindow *window);

Sets a widget's window. This function should only be used in a widget's GtkWidget::`realize()` implementation. The `window` passed is usually either new window created with `gdk_window_new()`, or the window of its parent widget as returned by `gtk_widget_get_parent_window()`.

Widgets must indicate whether they will create their own GdkWindow by calling `gtk_widget_set_has_window()`. This is usually done in the widget's `init()` function.

#### Parameters

widget | a GtkWidget |
window | a GdkWindow |

Since: 2.18

### gtk_widget_set_receives_default ()

    void
    gtk_widget_set_receives_default (GtkWidget *widget,
                                     gboolean receives_default);

Specifies whether `widget` will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.

See `gtk_widget_grab_default()` for details about the meaning of "default".

#### Parameters

widget | a GtkWidget |
receives_default | whether or not `widget` can be a default widget. |

Since: 2.18

### gtk_widget_get_receives_default ()

    gboolean
    gtk_widget_get_receives_default (GtkWidget *widget);

Determines whether `widget` is alyways treated as default widget withing its toplevel when it has the focus, even if another widget is the default.

See `gtk_widget_set_receives_default()`.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if `widget` acts as default widget when focussed, `FALSE` otherwise

Since: 2.18

### gtk_widget_set_realized ()

    void
    gtk_widget_set_realized (GtkWidget *widget,
                             gboolean realized);

Marks the widget as being realized.

This function should only ever be called in a derived widget's "realize" or "unrealize" implementation.

#### Parameters

widget | a GtkWidget |
realized | `TRUE` to mark the widget as realized |

Since: 2.20

### gtk_widget_get_realized ()

    gboolean
    gtk_widget_get_realized (GtkWidget *widget);

Determines whether `widget` is realized.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if `widget` is realized, `FALSE` otherwise

Since: 2.20

### gtk_widget_set_mapped ()

    void
    gtk_widget_set_mapped (GtkWidget *widget,
                           gboolean mapped);

Marks the widget as being realized.

This function should only ever be called in a derived widget's "map" or "unmap" implementation.

#### Parameters

widget | a GtkWidget |
mapped | `TRUE` to mark the widget as mapped |

Since: 2.20

### gtk_widget_get_mapped ()

    gboolean
    gtk_widget_get_mapped (GtkWidget *widget);

Whether the widget is mapped.

#### Parameters

widget | a GtkWidget |

#### Returns

`TRUE` if the widget is mapped, `FALSE` otherwise.

Since: 2.20

### gtk_widget_get_requisition ()

    void
    gtk_widget_get_requisition (GtkWidget *widget,
                                GtkRequisition *requisition);

Retrieves the widget's requisition.

This function should only be used by widget implementations in order to figure whether the widget's requisition has actually changed after some internal state change (so that they can call `gtk_widget_queue_resize()` instead of `gtk_widget_queue_draw()`).

Normally, `gtk_widget_size_request()` should be used.

#### Parameters

widget | a GtkWidget |
requisition | a pointer to a GtkRequisition to copy to. | [out]

Since: 2.20

### gtk_requisition_copy ()

    GtkRequisition *
    gtk_requisition_copy (const GtkRequisition *requisition);

Copies a GtkRequisition.

#### Parameters

requisition | a GtkRequisition |

#### Returns

a copy of `requisition`

### gtk_requisition_free ()

    void
    gtk_requisition_free (GtkRequisition *requisition);

Frees a GtkRequisition.

#### Parameters

requisition | a GtkRequisition |

## Types and Values

### GtkWidget

    typedef struct {
      /* The style for the widget. The style contains the
       *  colors the widget should be drawn in for each state
       *  along with graphics contexts used to draw with and
       *  the font to use for text.
       */
      GtkStyle *GSEAL (style);

      /* The widget's desired size.
       */
      GtkRequisition GSEAL (requisition);

      /* The widget's allocated size.
       */
      GtkAllocation GSEAL (allocation);

      /* The widget's window or its parent window if it does
       *  not have a window. (Which will be indicated by the
       *  GTK_NO_WINDOW flag being set).
       */
      GdkWindow *GSEAL (window);

      /* The widget's parent.
       */
      GtkWidget *GSEAL (parent);
    } GtkWidget;

### struct GtkWidgetClass

    struct GtkWidgetClass {
      /* The object class structure needs to be the first
       *  element in the widget class structure in order for
       *  the class mechanism to work correctly. This allows a
       *  GtkWidgetClass pointer to be cast to a GtkObjectClass
       *  pointer.
       */
      GtkObjectClass parent_class;

      guint activate_signal;

      guint set_scroll_adjustments_signal;
    };

`activate_signal` The signal to emit when a widget of this class is activated, `gtk_widget_activate()` handles the emission. Implementation of this signal is optional.

`set_scroll_adjustment_signal` This signal is emitted when a widget of this class is added to a scrolling aware parent, `gtk_widget_set_scroll_adjustments()` handles the emission. Implementation of this signal is optional.

### enum GtkWidgetFlags

Tells about certain properties of the widget.

#### Members

GTK_TOPLEVEL | widgets without a real parent, as there are GtkWindows and GtkMenus have this flag set throughout their lifetime. Toplevel widgets always contain their own GdkWindow. |
GTK_NO_WINDOW | Indicative for a widget that does not provide its own GdkWindow. Visible action (e.g. drawing) is performed on the parent's GdkWindow. |
GTK_REALIZED | Set by `gtk_widget_realize()`, unset by `gtk_widget_unrealize()`. A realized widget has an associated GdkWindow. |
GTK_MAPPED | Set by `gtk_widget_map()`, unset by `gtk_widget_unmap()`. Only realized widgets can be mapped. It means that `gdk_window_show()` has been called on the widgets window(s). |
GTK_VISIBLE | Set by `gtk_widget_show()`, unset by `gtk_widget_hide()`. Implies that a widget will be mapped as soon as its parent is mapped. |
GTK_SENSITIVE | Set and unset by `gtk_widget_set_sensitive()`. The sensitivity of a widget determines whether it will receive certain events (e.g. button or key presses). One premise for the widget's sensitivity is to have this flag set. |
GTK_PARENT_SENSITIVE | Set and unset by `gtk_widget_set_sensitive()` operations on the parents of the widget. This is the second premise for the widget's sensitivity. Once it has `GTK_SENSITIVE` and `GTK_PARENT_SENSITIVE` set, its state is effectively sensitive. This is expressed (and can be examined) by the GTK_WIDGET_IS_SENSITIVE macro. |
GTK_CAN_FOCUS | Determines whether a widget is able to handle focus grabs. |
GTK_HAS_FOCUS | Set by `gtk_widget_grab_focus()` for widgets that also have `GTK_CAN_FOCUS` set. The flag will be unset once another widget grabs the focus. |
GTK_CAN_DEFAULT | The widget is allowed to receive the default action via `gtk_widget_grab_default()` and will reserve space to draw the default if possible |
GTK_HAS_DEFAULT | The widget currently is receiving the default action and should be drawn appropriately if possible |
GTK_HAS_GRAB | Set by `gtk_grab_add()`, unset by `gtk_grab_remove()`. It means that the widget is in the grab_widgets stack, and will be the preferred one for receiving events other than ones of cosmetic value. |
GTK_RC_STYLE | Indicates that the widget's style has been looked up through the rc mechanism. It does not imply that the widget actually had a style defined through the rc mechanism. |
GTK_COMPOSITE_CHILD | Indicates that the widget is a composite child of its parent; see `gtk_widget_push_composite_child()`, `gtk_widget_pop_composite_child()`. |
GTK_NO_REPARENT | Unused since before GTK+ 1.2, will be removed in a future version. |
GTK_APP_PAINTABLE | Set and unset by `gtk_widget_set_app_paintable()`. Must be set on widgets whose window the application directly draws on, in order to keep GTK+ from overwriting the drawn stuff. See the section called “App-paintable widgets” for a detailed description of this flag. |
GTK_RECEIVES_DEFAULT | The widget when focused will receive the default action and have `GTK_HAS_DEFAULT` set even if there is a different widget set as default. |
GTK_DOUBLE_BUFFERED | Set and unset by `gtk_widget_set_double_buffered()`. Indicates that exposes done on the widget should be double-buffered. See the section called “Double buffering” for a detailed discussion of how double-buffering works in GTK+ and why you may want to disable it for special cases. |
GTK_NO_SHOW_ALL |  |

### struct GtkRequisition

    struct GtkRequisition {
      gint width;
      gint height;
    };

A GtkRequisition represents the desired size of a widget. See

??? for more information.

#### Members

gint `width`; | the widget's desired width |
gint `height`; | the widget's desired height |

### GtkAllocation

    typedef 	GdkRectangle	   GtkAllocation;

A GtkAllocation of a widget represents region which has been allocated to the widget by its parent. It is a subregion of its parents allocation. See

??? for more information.

### GtkSelectionData

    typedef struct {
      GdkAtom       GSEAL (selection);
      GdkAtom       GSEAL (target);
      GdkAtom       GSEAL (type);
      gint          GSEAL (format);
      guchar       *GSEAL (data);
      gint          GSEAL (length);
      GdkDisplay   *GSEAL (display);
    } GtkSelectionData;

### struct GtkWidgetAuxInfo

    struct GtkWidgetAuxInfo {
      gint x;
      gint y;
      gint width;
      gint height;
      guint x_set : 1;
      guint y_set : 1;
    };

### struct GtkWidgetShapeInfo

    struct GtkWidgetShapeInfo {
      gint16     offset_x;
      gint16     offset_y;
      GdkBitmap *shape_mask;
    };

### enum GtkWidgetHelpType

#### Members

GTK_WIDGET_HELP_TOOLTIP |  |
GTK_WIDGET_HELP_WHATS_THIS |  |

### enum GtkTextDirection

`GtkTextDirection` is deprecated and should not be used in newly-written code.

#### Members

GTK_TEXT_DIR_NONE |  |
GTK_TEXT_DIR_LTR |  |
GTK_TEXT_DIR_RTL |  |

## Property Details

### The `“app-paintable”` property

      “app-paintable”            gboolean

Whether the application will paint directly on the widget.

Flags: Read / Write

Default value: FALSE

### The `“can-default”` property

      “can-default”              gboolean

Whether the widget can be the default widget.

Flags: Read / Write

Default value: FALSE

### The `“can-focus”` property

      “can-focus”                gboolean

Whether the widget can accept the input focus.

Flags: Read / Write

Default value: FALSE

### The `“composite-child”` property

      “composite-child”          gboolean

Whether the widget is part of a composite widget.

Flags: Read

Default value: FALSE

### The `“double-buffered”` property

      “double-buffered”          gboolean

Whether or not the widget is double buffered.

Flags: Read / Write

Default value: TRUE

Since: 2.18

### The `“events”` property

      “events”                   GdkEventMask

The event mask that decides what kind of GdkEvents this widget gets.

Flags: Read / Write

Default value: GDK_STRUCTURE_MASK

### The `“extension-events”` property

      “extension-events”         GdkExtensionMode

The mask that decides what kind of extension events this widget gets.

Flags: Read / Write

Default value: GDK_EXTENSION_EVENTS_NONE

### The `“has-default”` property

      “has-default”              gboolean

Whether the widget is the default widget.

Flags: Read / Write

Default value: FALSE

### The `“has-focus”` property

      “has-focus”                gboolean

Whether the widget has the input focus.

Flags: Read / Write

Default value: FALSE

### The `“has-tooltip”` property

      “has-tooltip”              gboolean

Enables or disables the emission of “query-tooltip” on `widget` . A value of `TRUE` indicates that `widget` can have a tooltip, in this case the widget will be queried using “query-tooltip” to determine whether it will provide a tooltip or not.

Note that setting this property to `TRUE` for the first time will change the event masks of the GdkWindows of this widget to include leave-notify and motion-notify events. This cannot and will not be undone when the property is set to `FALSE` again.

Flags: Read / Write

Default value: FALSE

Since: 2.12

### The `“height-request”` property

      “height-request”           gint

Override for height request of the widget, or -1 if natural request should be used.

Flags: Read / Write

Allowed values: >= -1

Default value: -1

### The `“is-focus”` property

      “is-focus”                 gboolean

Whether the widget is the focus widget within the toplevel.

Flags: Read / Write

Default value: FALSE

### The `“name”` property

      “name”                     gchar *

The name of the widget.

Flags: Read / Write

Default value: NULL

### The `“no-show-all”` property

      “no-show-all”              gboolean

Whether gtk_widget_show_all() should not affect this widget.

Flags: Read / Write

Default value: FALSE

### The `“parent”` property

      “parent”                   GtkContainer *

The parent widget of this widget. Must be a Container widget.

Flags: Read / Write

### The `“receives-default”` property

      “receives-default”         gboolean

If TRUE, the widget will receive the default action when it is focused.

Flags: Read / Write

Default value: FALSE

### The `“sensitive”` property

      “sensitive”                gboolean

Whether the widget responds to input.

Flags: Read / Write

Default value: TRUE

### The `“style”` property

      “style”                    GtkStyle *

The style of the widget, which contains information about how it will look (colors etc).

Flags: Read / Write

### The `“tooltip-markup”` property

      “tooltip-markup”           gchar *

Sets the text of tooltip to be the given string, which is marked up with the Pango text markup language. Also see `gtk_tooltip_set_markup()`.

This is a convenience property which will take care of getting the tooltip shown if the given string is not `NULL`: “has-tooltip” will automatically be set to `TRUE` and there will be taken care of “query-tooltip” in the default signal handler.

Flags: Read / Write

Default value: NULL

Since: 2.12

### The `“tooltip-text”` property

      “tooltip-text”             gchar *

Sets the text of tooltip to be the given string.

Also see `gtk_tooltip_set_text()`.

This is a convenience property which will take care of getting the tooltip shown if the given string is not `NULL`: “has-tooltip” will automatically be set to `TRUE` and there will be taken care of “query-tooltip” in the default signal handler.

Flags: Read / Write

Default value: NULL

Since: 2.12

### The `“visible”` property

      “visible”                  gboolean

Whether the widget is visible.

Flags: Read / Write

Default value: FALSE

### The `“width-request”` property

      “width-request”            gint

Override for width request of the widget, or -1 if natural request should be used.

Flags: Read / Write

Allowed values: >= -1

Default value: -1

### The `“window”` property

      “window”                   GdkWindow *

The widget's window if it is realized, `NULL` otherwise.

Flags: Read

Since: 2.14

## Style Property Details

### The `“cursor-aspect-ratio”` style property

      “cursor-aspect-ratio”      gfloat

Aspect ratio with which to draw insertion cursor.

Flags: Read

Allowed values: [0,1]

Default value: 0.04

### The `“cursor-color”` style property

      “cursor-color”             GdkColor *

Color with which to draw insertion cursor.

Flags: Read

### The `“draw-border”` style property

      “draw-border”              GtkBorder *

The "draw-border" style property defines the size of areas outside the widget's allocation to draw.

`GtkWidget:draw-border` has been deprecated since version 2.22 and should not be used in newly-written code.

This property will be removed in GTK+ 3

Flags: Read

Since: 2.8

### The `“focus-line-pattern”` style property

      “focus-line-pattern”       gchar *

Dash pattern used to draw the focus indicator.

Flags: Read

Default value: "\001\001"

### The `“focus-line-width”` style property

      “focus-line-width”         gint

Width, in pixels, of the focus indicator line.

Flags: Read

Allowed values: >= 0

Default value: 1

### The `“focus-padding”` style property

      “focus-padding”            gint

Width, in pixels, between focus indicator and the widget 'box'.

Flags: Read

Allowed values: >= 0

Default value: 1

### The `“interior-focus”` style property

      “interior-focus”           gboolean

Whether to draw the focus indicator inside widgets.

Flags: Read

Default value: TRUE

### The `“link-color”` style property

      “link-color”               GdkColor *

The "link-color" style property defines the color of unvisited links.

Flags: Read

Since: 2.10

### The `“scroll-arrow-hlength”` style property

      “scroll-arrow-hlength”     gint

The "scroll-arrow-hlength" style property defines the length of horizontal scroll arrows.

Flags: Read

Allowed values: >= 1

Default value: 16

Since: 2.10

### The `“scroll-arrow-vlength”` style property

      “scroll-arrow-vlength”     gint

The "scroll-arrow-vlength" style property defines the length of vertical scroll arrows.

Flags: Read

Allowed values: >= 1

Default value: 16

Since: 2.10

### The `“secondary-cursor-color”` style property

      “secondary-cursor-color”   GdkColor *

Color with which to draw the secondary insertion cursor when editing mixed right-to-left and left-to-right text.

Flags: Read

### The `“separator-height”` style property

      “separator-height”         gint

The "separator-height" style property defines the height of separators. This property only takes effect if “wide-separators” is `TRUE`.

Flags: Read

Allowed values: >= 0

Default value: 0

Since: 2.10

### The `“separator-width”` style property

      “separator-width”          gint

The "separator-width" style property defines the width of separators. This property only takes effect if “wide-separators” is `TRUE`.

Flags: Read

Allowed values: >= 0

Default value: 0

Since: 2.10

### The `“tooltip-alpha”` style property

      “tooltip-alpha”            guchar

The "tooltip-alpha" style property defines the opacity of widget tooltips.

Flags: Read

Default value: 255

### The `“tooltip-radius”` style property

      “tooltip-radius”           guint

The "tooltip-radius" style property defines the radius of widget tooltips.

Flags: Read

Allowed values: <= G_MAXINT

Default value: 0

### The `“visited-link-color”` style property

      “visited-link-color”       GdkColor *

The "visited-link-color" style property defines the color of visited links.

Flags: Read

Since: 2.10

### The `“wide-separators”` style property

      “wide-separators”          gboolean

The "wide-separators" style property defines whether separators have configurable width and should be drawn using a box instead of a line.

Flags: Read

Default value: FALSE

Since: 2.10

## Signal Details

### The `“accel-closures-changed”` signal

    void
    user_function (GtkWidget *widget,
                   gpointer   user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

### The `“button-press-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::button-press-event signal will be emitted when a button (typically from a mouse) is pressed.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_BUTTON_PRESS_MASK mask.

This signal will be sent to the grab widget if there is one.

#### Parameters

widget | the object which received the signal. |
event | the GdkEventButton which triggered this signal. | [type Gdk.EventButton]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“button-release-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::button-release-event signal will be emitted when a button (typically from a mouse) is released.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_BUTTON_RELEASE_MASK mask.

This signal will be sent to the grab widget if there is one.

#### Parameters

widget | the object which received the signal. |
event | the GdkEventButton which triggered this signal. | [type Gdk.EventButton]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“can-activate-accel”` signal

    gboolean
    user_function (GtkWidget *widget,
                   guint      signal_id,
                   gpointer   user_data)

Determines whether an accelerator that activates the signal identified by `signal_id` can currently be activated. This signal is present to allow applications and derived widgets to override the default GtkWidget handling for determining whether an accelerator can be activated.

#### Parameters

widget | the object which received the signal |
signal_id | the ID of a signal installed on `widget` |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the signal can be activated.

Flags: Run Last

### The `“child-notify”` signal

    void
    user_function (GtkWidget  *widget,
                   GParamSpec *pspec,
                   gpointer    user_data)

The ::child-notify signal is emitted for each

child property that has

changed on an object. The signal's detail holds the property name.

#### Parameters

widget | the object which received the signal |
pspec | the GParamSpec of the changed child property |
user_data | user data set when the signal handler was connected. |

Flags: No Hooks

### The `“client-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::client-event will be emitted when the `widget` 's window receives a message (via a ClientMessage event) from another application.

#### Parameters

widget | the object which received the signal |
event | the GdkEventClient which triggered this signal. | [type Gdk.EventClient]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“composited-changed”` signal

    void
    user_function (GtkWidget *widget,
                   gpointer   user_data)

The ::composited-changed signal is emitted when the composited status of `widget` s screen changes. See `gdk_screen_is_composited()`.

#### Parameters

widget | the object on which the signal is emitted |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“configure-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::configure-event signal will be emitted when the size, position or stacking of the `widget` 's window has changed.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_STRUCTURE_MASK mask. GDK will enable this mask automatically for all new windows.

#### Parameters

widget | the object which received the signal |
event | the GdkEventConfigure which triggered this signal. | [type Gdk.EventConfigure]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“damage-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

Emitted when a redirected window belonging to `widget` gets drawn into. The region/area members of the event shows what area of the redirected drawable was drawn into.

#### Parameters

widget | the object which received the signal |
event | the GdkEventExpose event |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

Since: 2.14

### The `“delete-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::delete-event signal is emitted if a user requests that a toplevel window is closed. The default handler for this signal destroys the window. Connecting `gtk_widget_hide_on_delete()` to this signal will cause the window to be hidden instead, so that it can later be shown again without reconstructing it.

#### Parameters

widget | the object which received the signal |
event | the event which triggered this signal |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“destroy-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::destroy-event signal is emitted when a GdkWindow is destroyed. You rarely get this signal, because most widgets disconnect themselves from their window before they destroy it, so no widget owns the window at destroy time.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_STRUCTURE_MASK mask. GDK will enable this mask automatically for all new windows.

#### Parameters

widget | the object which received the signal. |
event | the event which triggered this signal |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“direction-changed”` signal

    void
    user_function (GtkWidget       *widget,
                   GtkTextDirection previous_direction,
                   gpointer         user_data)

The ::direction-changed signal is emitted when the text direction of a widget changes.

#### Parameters

widget | the object on which the signal is emitted |
previous_direction | the previous text direction of `widget` |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“drag-begin”` signal

    void
    user_function (GtkWidget      *widget,
                   GdkDragContext *drag_context,
                   gpointer        user_data)

The ::drag-begin signal is emitted on the drag source when a drag is started. A typical reason to connect to this signal is to set up a custom drag icon with `gtk_drag_source_set_icon()`.

Note that some widgets set up a drag icon in the default handler of this signal, so you may have to use `g_signal_connect_after()` to override what the default handler did.

#### Parameters

widget | the object which received the signal |
drag_context | the drag context |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“drag-data-delete”` signal

    void
    user_function (GtkWidget      *widget,
                   GdkDragContext *drag_context,
                   gpointer        user_data)

The ::drag-data-delete signal is emitted on the drag source when a drag with the action `GDK_ACTION_MOVE` is successfully completed. The signal handler is responsible for deleting the data that has been dropped. What "delete" means depends on the context of the drag operation.

#### Parameters

widget | the object which received the signal |
drag_context | the drag context |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“drag-data-get”` signal

    void
    user_function (GtkWidget        *widget,
                   GdkDragContext   *drag_context,
                   GtkSelectionData *data,
                   guint             info,
                   guint             time,
                   gpointer          user_data)

The ::drag-data-get signal is emitted on the drag source when the drop site requests the data which is dragged. It is the responsibility of the signal handler to fill `data` with the data in the format which is indicated by `info` . See `gtk_selection_data_set()` and `gtk_selection_data_set_text()`.

#### Parameters

widget | the object which received the signal |
drag_context | the drag context |
data | the GtkSelectionData to be filled with the dragged data |
info | the info that has been registered with the target in the GtkTargetList |
time | the timestamp at which the data was requested |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“drag-data-received”` signal

    void
    user_function (GtkWidget        *widget,
                   GdkDragContext   *drag_context,
                   gint              x,
                   gint              y,
                   GtkSelectionData *data,
                   guint             info,
                   guint             time,
                   gpointer          user_data)

The ::drag-data-received signal is emitted on the drop site when the dragged data has been received. If the data was received in order to determine whether the drop will be accepted, the handler is expected to call `gdk_drag_status()` and not finish the drag. If the data was received in response to a “drag-drop” signal (and this is the last target to be received), the handler for this signal is expected to process the received data and then call `gtk_drag_finish()`, setting the `success` parameter depending on whether the data was processed successfully.

The handler may inspect and modify `drag_context->action` before calling `gtk_drag_finish()`, e.g. to implement `GDK_ACTION_ASK` as shown in the following example:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    void

    drag_data_received (GtkWidget          *widget,
                        GdkDragContext     *drag_context,
                        gint                x,
                        gint                y,
                        GtkSelectionData   *data,
                        guint               info,
                        guint               time)
    {
      if ((data->length >= 0) && (data->format == 8))
        {
          if (drag_context->action == GDK_ACTION_ASK)

            {
              GtkWidget *dialog;
              gint response;

              dialog = gtk_message_dialog_new (NULL,
                                               GTK_DIALOG_MODAL |

                                               GTK_DIALOG_DESTROY_WITH_PARENT,
                                               GTK_MESSAGE_INFO,
                                               GTK_BUTTONS_YES_NO,
                                               "Move the data ?\n");
              response = gtk_dialog_run (GTK_DIALOG (dialog));
              gtk_widget_destroy (dialog);

              if (response == GTK_RESPONSE_YES)
                drag_context->action = GDK_ACTION_MOVE;
              else
                drag_context->action = GDK_ACTION_COPY;
             }

          gtk_drag_finish (drag_context, TRUE, FALSE, time);
          return;
        }

       gtk_drag_finish (drag_context, FALSE, FALSE, time);
     }

#### Parameters

widget | the object which received the signal |
drag_context | the drag context |
x | where the drop happened |
y | where the drop happened |
data | the received data |
info | the info that has been registered with the target in the GtkTargetList |
time | the timestamp at which the data was received |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“drag-drop”` signal

    gboolean
    user_function (GtkWidget      *widget,
                   GdkDragContext *drag_context,
                   gint            x,
                   gint            y,
                   guint           time,
                   gpointer        user_data)

The ::drag-drop signal is emitted on the drop site when the user drops the data onto the widget. The signal handler must determine whether the cursor position is in a drop zone or not. If it is not in a drop zone, it returns `FALSE` and no further processing is necessary. Otherwise, the handler returns `TRUE`. In this case, the handler must ensure that `gtk_drag_finish()` is called to let the source know that the drop is done. The call to `gtk_drag_finish()` can be done either directly or in a “drag-data-received” handler which gets triggered by calling `gtk_drag_get_data()` to receive the data for one or more of the supported targets.

#### Parameters

widget | the object which received the signal |
drag_context | the drag context |
x | the x coordinate of the current cursor position |
y | the y coordinate of the current cursor position |
time | the timestamp of the motion event |
returns | whether the cursor position is in a drop zone |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“drag-end”` signal

    void
    user_function (GtkWidget      *widget,
                   GdkDragContext *drag_context,
                   gpointer        user_data)

The ::drag-end signal is emitted on the drag source when a drag is finished. A typical reason to connect to this signal is to undo things done in “drag-begin”.

#### Parameters

widget | the object which received the signal |
drag_context | the drag context |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“drag-failed”` signal

    gboolean
    user_function (GtkWidget      *widget,
                   GdkDragContext *drag_context,
                   GtkDragResult   result,
                   gpointer        user_data)

The ::drag-failed signal is emitted on the drag source when a drag has failed. The signal handler may hook custom code to handle a failed DND operation based on the type of error, it returns `TRUE` is the failure has been already handled (not showing the default "drag operation failed" animation), otherwise it returns `FALSE`.

#### Parameters

widget | the object which received the signal |
drag_context | the drag context |
result | the result of the drag operation |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the failed drag operation has been already handled.

Flags: Run Last

Since: 2.12

### The `“drag-leave”` signal

    void
    user_function (GtkWidget      *widget,
                   GdkDragContext *drag_context,
                   guint           time,
                   gpointer        user_data)

The ::drag-leave signal is emitted on the drop site when the cursor leaves the widget. A typical reason to connect to this signal is to undo things done in “drag-motion”, e.g. undo highlighting with `gtk_drag_unhighlight()`

#### Parameters

widget | the object which received the signal. |
drag_context | the drag context |
time | the timestamp of the motion event |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“drag-motion”` signal

    gboolean
    user_function (GtkWidget      *widget,
                   GdkDragContext *drag_context,
                   gint            x,
                   gint            y,
                   guint           time,
                   gpointer        user_data)

The drag-motion signal is emitted on the drop site when the user moves the cursor over the widget during a drag. The signal handler must determine whether the cursor position is in a drop zone or not. If it is not in a drop zone, it returns `FALSE` and no further processing is necessary. Otherwise, the handler returns `TRUE`. In this case, the handler is responsible for providing the necessary information for displaying feedback to the user, by calling `gdk_drag_status()`.

If the decision whether the drop will be accepted or rejected can't be made based solely on the cursor position and the type of the data, the handler may inspect the dragged data by calling `gtk_drag_get_data()` and defer the `gdk_drag_status()` call to the “drag-data-received” handler. Note that you cannot not pass GTK_DEST_DEFAULT_DROP, GTK_DEST_DEFAULT_MOTION or GTK_DEST_DEFAULT_ALL to `gtk_drag_dest_set()` when using the drag-motion signal that way.

Also note that there is no drag-enter signal. The drag receiver has to keep track of whether he has received any drag-motion signals since the last “drag-leave” and if not, treat the drag-motion signal as an "enter" signal. Upon an "enter", the handler will typically highlight the drop site with `gtk_drag_highlight()`.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    static void
    drag_motion (GtkWidget *widget,
                 GdkDragContext *context,
                 gint x,
                 gint y,
                 guint time)
    {
      GdkAtom target;

      PrivateData *private_data = GET_PRIVATE_DATA (widget);

      if (!private_data->drag_highlight)

       {
         private_data->drag_highlight = 1;
         gtk_drag_highlight (widget);
       }

      target = gtk_drag_dest_find_target (widget, context, NULL);
      if (target == GDK_NONE)
        gdk_drag_status (context, 0, time);
      else

       {
         private_data->pending_status = context->suggested_action;
         gtk_drag_get_data (widget, context, target, time);
       }

      return TRUE;
    }

    static void
    drag_data_received (GtkWidget        *widget,
                        GdkDragContext   *context,
                        gint              x,
                        gint              y,
                        GtkSelectionData *selection_data,
                        guint             info,
                        guint             time)
    {
      PrivateData *private_data = GET_PRIVATE_DATA (widget);

      if (private_data->suggested_action)

       {
         private_data->suggested_action = 0;

        /* We are getting this data due to a request in drag_motion,
         * rather than due to a request in drag_drop, so we are just
         * supposed to call gdk_drag_status (), not actually paste in

         * the data.
         */
         str = gtk_selection_data_get_text (selection_data);
         if (!data_is_acceptable (str))

           gdk_drag_status (context, 0, time);
         else
           gdk_drag_status (context, private_data->suggested_action, time);
       }
      else
       {
         /* accept the drop */
       }
    }

#### Parameters

widget | the object which received the signal |
drag_context | the drag context |
x | the x coordinate of the current cursor position |
y | the y coordinate of the current cursor position |
time | the timestamp of the motion event |
returns | whether the cursor position is in a drop zone |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“enter-notify-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::enter-notify-event will be emitted when the pointer enters the `widget` 's window.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_ENTER_NOTIFY_MASK mask.

This signal will be sent to the grab widget if there is one.

#### Parameters

widget | the object which received the signal |
event | the GdkEventCrossing which triggered this signal. | [type Gdk.EventCrossing]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The GTK+ main loop will emit three signals for each GDK event delivered to a widget: one generic ::event signal, another, more specific, signal that matches the type of event delivered (e.g. “key-press-event”) and finally a generic “event-after” signal.

#### Parameters

widget | the object which received the signal. |
event | the GdkEvent which triggered this signal |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event and to cancel the emission of the second specific ::event signal. `FALSE` to propagate the event further and to allow the emission of the second signal. The ::event-after signal is emitted regardless of the return value.

Flags: Run Last

### The `“event-after”` signal

    void
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

After the emission of the “event” signal and (optionally) the second more specific signal, ::event-after will be emitted regardless of the previous two signals handlers return values.

#### Parameters

widget | the object which received the signal. |
event | the GdkEvent which triggered this signal |
user_data | user data set when the signal handler was connected. |

### The `“expose-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::expose-event signal is emitted when an area of a previously obscured GdkWindow is made visible and needs to be redrawn. GTK_NO_WINDOW widgets will get a synthesized event from their parent widget.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_EXPOSURE_MASK mask.

Note that the ::expose-event signal has been replaced by a ::draw signal in GTK+ 3. The GTK+ 3 migration guide for hints on how to port from ::expose-event to ::draw.

#### Parameters

widget | the object which received the signal. |
event | the GdkEventExpose which triggered this signal. | [type Gdk.EventExpose]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“focus”` signal

    gboolean
    user_function (GtkWidget       *widget,
                   GtkDirectionType direction,
                   gpointer         user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“focus-in-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::focus-in-event signal will be emitted when the keyboard focus enters the `widget` 's window.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_FOCUS_CHANGE_MASK mask.

#### Parameters

widget | the object which received the signal |
event | the GdkEventFocus which triggered this signal. | [type Gdk.EventFocus]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“focus-out-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::focus-out-event signal will be emitted when the keyboard focus leaves the `widget` 's window.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_FOCUS_CHANGE_MASK mask.

#### Parameters

widget | the object which received the signal |
event | the GdkEventFocus which triggered this signal. | [type Gdk.EventFocus]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“grab-broken-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

Emitted when a pointer or keyboard grab on a window belonging to `widget` gets broken.

On X11, this happens when the grab window becomes unviewable (i.e. it or one of its ancestors is unmapped), or if the same application grabs the pointer or keyboard again.

#### Parameters

widget | the object which received the signal |
event | the GdkEventGrabBroken event |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

Since: 2.8

### The `“grab-focus”` signal

    void
    user_function (GtkWidget *widget,
                   gpointer   user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“grab-notify”` signal

    void
    user_function (GtkWidget *widget,
                   gboolean   was_grabbed,
                   gpointer   user_data)

The ::grab-notify signal is emitted when a widget becomes shadowed by a GTK+ grab (not a pointer or keyboard grab) on another widget, or when it becomes unshadowed due to a grab being removed.

A widget is shadowed by a `gtk_grab_add()` when the topmost grab widget in the grab stack of its window group is not its ancestor.

#### Parameters

widget | the object which received the signal |
was_grabbed | `FALSE` if the widget becomes shadowed, `TRUE` if it becomes unshadowed |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“hide”` signal

    void
    user_function (GtkWidget *widget,
                   gpointer   user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“hierarchy-changed”` signal

    void
    user_function (GtkWidget *widget,
                   GtkWidget *previous_toplevel,
                   gpointer   user_data)

The ::hierarchy-changed signal is emitted when the anchored state of a widget changes. A widget is anchored when its toplevel ancestor is a GtkWindow. This signal is emitted when a widget changes from un-anchored to anchored or vice-versa.

#### Parameters

widget | the object on which the signal is emitted |
previous_toplevel | the previous toplevel ancestor, or `NULL` if the widget was previously unanchored. | [allow-none]
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“key-press-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::key-press-event signal is emitted when a key is pressed.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_KEY_PRESS_MASK mask.

This signal will be sent to the grab widget if there is one.

#### Parameters

widget | the object which received the signal |
event | the GdkEventKey which triggered this signal. | [type Gdk.EventKey]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“key-release-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::key-release-event signal is emitted when a key is pressed.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_KEY_RELEASE_MASK mask.

This signal will be sent to the grab widget if there is one.

#### Parameters

widget | the object which received the signal |
event | the GdkEventKey which triggered this signal. | [type Gdk.EventKey]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“keynav-failed”` signal

    gboolean
    user_function (GtkWidget       *widget,
                   GtkDirectionType direction,
                   gpointer         user_data)

Gets emitted if keyboard navigation fails. See `gtk_widget_keynav_failed()` for details.

#### Parameters

widget | the object which received the signal |
direction | the direction of movement |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if stopping keyboard navigation is fine, `FALSE` if the emitting widget should try to handle the keyboard navigation attempt in its parent container(s).

Flags: Run Last

Since: 2.12

### The `“leave-notify-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::leave-notify-event will be emitted when the pointer leaves the `widget` 's window.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_LEAVE_NOTIFY_MASK mask.

This signal will be sent to the grab widget if there is one.

#### Parameters

widget | the object which received the signal |
event | the GdkEventCrossing which triggered this signal. | [type Gdk.EventCrossing]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“map”` signal

    void
    user_function (GtkWidget *widget,
                   gpointer   user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“map-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::map-event signal will be emitted when the `widget` 's window is mapped. A window is mapped when it becomes visible on the screen.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_STRUCTURE_MASK mask. GDK will enable this mask automatically for all new windows.

#### Parameters

widget | the object which received the signal |
event | the GdkEventAny which triggered this signal. | [type Gdk.EventAny]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“mnemonic-activate”` signal

    gboolean
    user_function (GtkWidget *widget,
                   gboolean   arg1,
                   gpointer   user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“motion-notify-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::motion-notify-event signal is emitted when the pointer moves over the widget's GdkWindow.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_POINTER_MOTION_MASK mask.

This signal will be sent to the grab widget if there is one.

#### Parameters

widget | the object which received the signal. |
event | the GdkEventMotion which triggered this signal. | [type Gdk.EventMotion]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“move-focus”` signal

    void
    user_function (GtkWidget       *widget,
                   GtkDirectionType direction,
                   gpointer         user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“no-expose-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::no-expose-event will be emitted when the `widget` 's window is drawn as a copy of another GdkDrawable (with `gdk_draw_drawable()` or `gdk_window_copy_area()`) which was completely unobscured. If the source window was partially obscured GdkEventExpose events will be generated for those areas.

#### Parameters

widget | the object which received the signal |
event | the GdkEventNoExpose which triggered this signal. | [type Gdk.EventNoExpose]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“parent-set”` signal

    void
    user_function (GtkWidget *widget,
                   GtkWidget *old_parent,
                   gpointer   user_data)

The ::parent-set signal is emitted when a new parent has been set on a widget.

#### Parameters

widget | the object on which the signal is emitted |
old_parent | the previous parent, or `NULL` if the widget just got its initial parent. | [allow-none]
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“popup-menu”` signal

    gboolean
    user_function (GtkWidget *widget,
                   gpointer   user_data)

This signal gets emitted whenever a widget should pop up a context menu. This usually happens through the standard key binding mechanism; by pressing a certain key while a widget is focused, the user can cause the widget to pop up a menu. For example, the GtkEntry widget creates a menu with clipboard commands. See the section called “Implement GtkWidget::popup_menu” for an example of how to use this signal.

#### Parameters

widget | the object which received the signal |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if a menu was activated

Flags: Action

### The `“property-notify-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::property-notify-event signal will be emitted when a property on the `widget` 's window has been changed or deleted.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_PROPERTY_CHANGE_MASK mask.

#### Parameters

widget | the object which received the signal |
event | the GdkEventProperty which triggered this signal. | [type Gdk.EventProperty]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“proximity-in-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

To receive this signal the GdkWindow associated to the widget needs to enable the GDK_PROXIMITY_IN_MASK mask.

This signal will be sent to the grab widget if there is one.

#### Parameters

widget | the object which received the signal |
event | the GdkEventProximity which triggered this signal. | [type Gdk.EventProximity]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“proximity-out-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

To receive this signal the GdkWindow associated to the widget needs to enable the GDK_PROXIMITY_OUT_MASK mask.

This signal will be sent to the grab widget if there is one.

#### Parameters

widget | the object which received the signal |
event | the GdkEventProximity which triggered this signal. | [type Gdk.EventProximity]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“query-tooltip”` signal

    gboolean
    user_function (GtkWidget  *widget,
                   gint        x,
                   gint        y,
                   gboolean    keyboard_mode,
                   GtkTooltip *tooltip,
                   gpointer    user_data)

Emitted when “has-tooltip” is `TRUE` and the “gtk-tooltip-timeout” has expired with the cursor hovering "above" `widget` ; or emitted when `widget` got focus in keyboard mode.

Using the given coordinates, the signal handler should determine whether a tooltip should be shown for `widget` . If this is the case `TRUE` should be returned, `FALSE` otherwise. Note that if `keyboard_mode` is `TRUE`, the values of `x` and `y` are undefined and should not be used.

The signal handler is free to manipulate `tooltip` with the therefore destined function calls.

#### Parameters

widget | the object which received the signal |
x | the x coordinate of the cursor position where the request has been emitted, relative to `widget->window` |
y | the y coordinate of the cursor position where the request has been emitted, relative to `widget->window` |
keyboard_mode | `TRUE` if the tooltip was trigged using the keyboard |
tooltip | a GtkTooltip |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if `tooltip` should be shown right now, `FALSE` otherwise.

Flags: Run Last

Since: 2.12

### The `“realize”` signal

    void
    user_function (GtkWidget *widget,
                   gpointer   user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“screen-changed”` signal

    void
    user_function (GtkWidget *widget,
                   GdkScreen *previous_screen,
                   gpointer   user_data)

The ::screen-changed signal gets emitted when the screen of a widget has changed.

#### Parameters

widget | the object on which the signal is emitted |
previous_screen | the previous screen, or `NULL` if the widget was not associated with a screen before. | [allow-none]
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“scroll-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::scroll-event signal is emitted when a button in the 4 to 7 range is pressed. Wheel mice are usually configured to generate button press events for buttons 4 and 5 when the wheel is turned.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_BUTTON_PRESS_MASK mask.

This signal will be sent to the grab widget if there is one.

#### Parameters

widget | the object which received the signal. |
event | the GdkEventScroll which triggered this signal. | [type Gdk.EventScroll]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“selection-clear-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::selection-clear-event signal will be emitted when the the `widget` 's window has lost ownership of a selection.

#### Parameters

widget | the object which received the signal |
event | the GdkEventSelection which triggered this signal. | [type Gdk.EventSelection]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“selection-get”` signal

    void
    user_function (GtkWidget        *widget,
                   GtkSelectionData *data,
                   guint             info,
                   guint             time,
                   gpointer          user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“selection-notify-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“selection-received”` signal

    void
    user_function (GtkWidget        *widget,
                   GtkSelectionData *data,
                   guint             time,
                   gpointer          user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“selection-request-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::selection-request-event signal will be emitted when another client requests ownership of the selection owned by the `widget` 's window.

#### Parameters

widget | the object which received the signal |
event | the GdkEventSelection which triggered this signal. | [type Gdk.EventSelection]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“show”` signal

    void
    user_function (GtkWidget *widget,
                   gpointer   user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“show-help”` signal

    gboolean
    user_function (GtkWidget        *widget,
                   GtkWidgetHelpType help_type,
                   gpointer          user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“size-allocate”` signal

    void
    user_function (GtkWidget    *widget,
                   GdkRectangle *allocation,
                   gpointer      user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“size-request”` signal

    void
    user_function (GtkWidget      *widget,
                   GtkRequisition *requisition,
                   gpointer        user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“state-changed”` signal

    void
    user_function (GtkWidget   *widget,
                   GtkStateType state,
                   gpointer     user_data)

The ::state-changed signal is emitted when the widget state changes. See `gtk_widget_get_state()`.

#### Parameters

widget | the object which received the signal. |
state | the previous state |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“style-set”` signal

    void
    user_function (GtkWidget *widget,
                   GtkStyle  *previous_style,
                   gpointer   user_data)

The ::style-set signal is emitted when a new style has been set on a widget. Note that style-modifying functions like `gtk_widget_modify_base()` also cause this signal to be emitted.

#### Parameters

widget | the object on which the signal is emitted |
previous_style | the previous style, or `NULL` if the widget just got its initial style. | [allow-none]
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“unmap”` signal

    void
    user_function (GtkWidget *widget,
                   gpointer   user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“unmap-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::unmap-event signal will be emitted when the `widget` 's window is unmapped. A window is unmapped when it becomes invisible on the screen.

To receive this signal, the GdkWindow associated to the widget needs to enable the GDK_STRUCTURE_MASK mask. GDK will enable this mask automatically for all new windows.

#### Parameters

widget | the object which received the signal |
event | the GdkEventAny which triggered this signal. | [type Gdk.EventAny]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“unrealize”` signal

    void
    user_function (GtkWidget *widget,
                   gpointer   user_data)

#### Parameters

widget | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“visibility-notify-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::visibility-notify-event will be emitted when the `widget` 's window is obscured or unobscured.

To receive this signal the GdkWindow associated to the widget needs to enable the GDK_VISIBILITY_NOTIFY_MASK mask.

#### Parameters

widget | the object which received the signal |
event | the GdkEventVisibility which triggered this signal. | [type Gdk.EventVisibility]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last

### The `“window-state-event”` signal

    gboolean
    user_function (GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   user_data)

The ::window-state-event will be emitted when the state of the toplevel window associated to the `widget` changes.

To receive this signal the GdkWindow associated to the widget needs to enable the GDK_STRUCTURE_MASK mask. GDK will enable this mask automatically for all new windows.

#### Parameters

widget | the object which received the signal |
event | the GdkEventWindowState which triggered this signal. | [type Gdk.EventWindowState]
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked for the event. `FALSE` to propagate the event further.

Flags: Run Last